Attribute VB_Name = "Input"
'*****************************************
'**       MADE WITH MIRAGE ENGINE       **
'**        Maintained by Xlithan        **
'*****************************************
Option Explicit

' keyboard input declares
Private Declare Function GetAsyncKeyState Lib "user32.dll" (ByVal vKey As Long) As Integer
Private Declare Function GetKeyState Lib "user32.dll" (ByVal nVirtKey As Long) As Integer
Public Declare Function GetForegroundWindow Lib "user32" () As Long

' player input text buffer
Public MyText As String

' Game direction vars
Public DirUp As Boolean
Public DirDown As Boolean
Public DirLeft As Boolean
Public DirRight As Boolean
Public ShiftDown As Boolean
Public ControlDown As Boolean

' Key constants
Private Const VK_UP As Long = &H26
Private Const VK_DOWN As Long = &H28
Private Const VK_LEFT As Long = &H25
Private Const VK_RIGHT As Long = &H27
Private Const VK_SHIFT As Long = &H10
'Private Const VK_RETURN As Long = &HD ' not used
Private Const VK_CONTROL As Long = &H11

Public Sub CheckInputKeys()
Dim Buffer As clsBuffer
Dim InvNum As Long

    ' Check to make sure they aren't trying to auto do anything
    If GetAsyncKeyState(VK_UP) >= 0 Then DirUp = False
    If GetAsyncKeyState(VK_DOWN) >= 0 Then DirDown = False
    If GetAsyncKeyState(VK_LEFT) >= 0 Then DirLeft = False
    If GetAsyncKeyState(VK_RIGHT) >= 0 Then DirRight = False
    If GetAsyncKeyState(VK_CONTROL) >= 0 Then ControlDown = False
    If GetAsyncKeyState(VK_SHIFT) >= 0 Then ShiftDown = False
    
    If frmMainGame.WindowState = vbMinimized Then Exit Sub
    
    ' Keyboard keypresses
    If GetKeyState(vbKeyShift) < 0 Then
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        ShiftDown = True
    Else
        ShiftDown = False
    End If
    
    If GetKeyState(vbKeyReturn) < 0 Then
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        CheckMapGetItem
    End If
    
    If GetKeyState(vbKeyControl) < 0 Then
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        ControlDown = True
    Else
        ControlDown = False
    End If
    
    'Move Up
    If GetKeyState(vbKeyUp) < 0 Then
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        DirUp = True
        DirDown = False
        DirLeft = False
        DirRight = False
        Exit Sub
    Else
        DirUp = False
    End If
    
    'Move Right
    If GetKeyState(vbKeyRight) < 0 Then
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        DirUp = False
        DirDown = False
        DirLeft = False
        DirRight = True
        Exit Sub
    Else
        DirRight = False
    End If
    
    'Move down
    If GetKeyState(vbKeyDown) < 0 Then
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        DirUp = False
        DirDown = True
        DirLeft = False
        DirRight = False
        Exit Sub
    Else
        DirDown = False
    End If
    
    'Move left
    If GetKeyState(vbKeyLeft) < 0 Then
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        DirUp = False
        DirDown = False
        DirLeft = True
        DirRight = False
        Exit Sub
    Else
        DirLeft = False
    End If
    
    ''''''''''''''''''''''''''''''''''''''''''' Joypad
    
    ' Joypad keypresses
    If joyGetPosEx(JNum, JI) <> 0 Then Exit Sub
    
    If JI.dwButtons = 4 Then ' X button
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        ShiftDown = True
    Else
        ShiftDown = False
    End If
    
    If JI.dwButtons = 128 And btnPadDown = False Then ' Start Button
        If frmMainGame.picGUI.Visible = True Then
            frmMainGame.picGUI.Visible = False
        Else
            frmMainGame.picInvList.Visible = False
            frmMainGame.picSpellsList.Visible = False
            frmMainGame.picGUI.Visible = True
        End If
        btnPadDown = True
    End If
    
    If JI.dwButtons = 8 And btnPadDown = False Then ' Y button
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        ' Use item/spell
        If frmMainGame.picInvList.Visible Then
            InvNum = frmMainGame.lstInv.ListIndex + 1
            
            If GetPlayerInvItemNum(MyIndex, InvNum) > 0 Then
                If GetPlayerInvItemNum(MyIndex, InvNum) <= MAX_ITEMS Then
                    If Item(GetPlayerInvItemNum(MyIndex, InvNum)).Type = ITEM_TYPE_CURRENCY Then
                        ' Show them the drop dialog
                        frmDrop.Show vbModal
                    Else
                        Call SendDropItem(frmMainGame.lstInv.ListIndex + 1, 0)
                        
                        ' clear inventory graphic
                        frmMainGame.picInvSelected.Cls
                    End If
                End If
            End If
        Else
            CheckMapGetItem
        End If
        btnPadDown = True
    End If
    
    If JI.dwButtons = 2 Then ' B button
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        ControlDown = True
    Else
        ControlDown = False
    End If
    
    If JI.dwButtons = 1 Then ' A button
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        ' Use item/spell
        If frmMainGame.picInvList.Visible Then
            Call UseItem
        ElseIf frmMainGame.picSpellsList.Visible Then
            Call CastSpell
        End If
    End If
    
    If JI.dwButtons = 16 And btnPadDown = False Then ' L-button
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        ' Stats
        Set Buffer = New clsBuffer

        Buffer.PreAllocate 2
        Buffer.WriteInteger CGetStats
        Call SendData(Buffer.ToArray())
        
        Set Buffer = Nothing
        btnPadDown = True
    End If
    
    '''' Doesn't seem to be able to close the form, might be better to place a picture box on main game form instead
'    If JI.dwButtons = 32 And btnPadDown = False Then ' R-button
'        ' Train
'        If frmTraining.Visible = False Then
'            frmTraining.Show
'        Else
'            frmTraining.Hide
'        End If
'        btnPadDown = True
'    End If
    
    'Inventory/Spell list select
    ' Up
    If (JI.dwPOV / 100) = 0 Then
        If frmMainGame.picInvList.Visible Then
            If frmMainGame.lstInv.ListIndex > 0 Then
                frmMainGame.lstInv.ListIndex = frmMainGame.lstInv.ListIndex - 1
            End If
            InventoryItemSelected = frmMainGame.lstInv.ListIndex + 1
            frmMainGame.lblInvSelected.Caption = "<slot " & InventoryItemSelected & ">"
            
            If GetPlayerInvItemNum(MyIndex, InventoryItemSelected) > 0 Then
                Call BltInventory(GetPlayerInvItemNum(MyIndex, InventoryItemSelected))
            Else
                frmMainGame.picInvSelected.Cls
            End If
        End If
        If frmMainGame.picSpellsList.Visible Then
            If frmMainGame.lstSpells.ListIndex > 0 Then
                frmMainGame.lstSpells.ListIndex = frmMainGame.lstSpells.ListIndex - 1
            End If
            SpellSelected = frmMainGame.lstSpells.ListIndex + 1
            frmMainGame.lblSpellSelected.Caption = "<slot " & SpellSelected & ">"
        End If
    End If
    
    ' Down
    If (JI.dwPOV / 100) = 180 Then
        If frmMainGame.picInvList.Visible Then
            If frmMainGame.lstInv.ListIndex < MAX_INV - 1 Then
                frmMainGame.lstInv.ListIndex = frmMainGame.lstInv.ListIndex + 1
            End If
            InventoryItemSelected = frmMainGame.lstInv.ListIndex + 1
            frmMainGame.lblInvSelected.Caption = "<slot " & InventoryItemSelected & ">"
            
            If GetPlayerInvItemNum(MyIndex, InventoryItemSelected) > 0 Then
                Call BltInventory(GetPlayerInvItemNum(MyIndex, InventoryItemSelected))
            Else
                frmMainGame.picInvSelected.Cls
            End If
        End If
        If frmMainGame.picSpellsList.Visible Then
            If frmMainGame.lstSpells.ListIndex < MAX_PLAYER_SPELLS - 1 Then
                frmMainGame.lstSpells.ListIndex = frmMainGame.lstSpells.ListIndex + 1
            End If
            SpellSelected = frmMainGame.lstSpells.ListIndex + 1
            frmMainGame.lblSpellSelected.Caption = "<slot " & SpellSelected & ">"
        End If
    End If
    
    'Inventory
    If (JI.dwPOV / 100) = 270 And btnPOVDown = False Then
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        If frmMainGame.picSpellsList.Visible Then
            frmMainGame.picSpellsList.Visible = False
        End If
        Call UpdateInventory
        frmMainGame.picInvList.Visible = (Not frmMainGame.picInvList.Visible)
        btnPOVDown = True
    End If
    
    'Spells
    If (JI.dwPOV / 100) = 90 And btnPOVDown = False Then
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        Set Buffer = New clsBuffer
        If frmMainGame.picInvList.Visible Then
            frmMainGame.picInvList.Visible = False
        End If
        If frmMainGame.picSpellsList.Visible Then
            frmMainGame.picSpellsList.Visible = False
        Else
            Buffer.PreAllocate 2
            Buffer.WriteInteger CSpells
            Call SendData(Buffer.ToArray())
            
            Set Buffer = Nothing
        End If
        btnPOVDown = True
    End If
    
    'Reset POV status
    If JI.dwPOV = 65535 Then
        btnPOVDown = False
    End If
    
    'Reset Pad Button status
    If JI.dwButtons = 0 Then
        btnPadDown = False
    End If
    
    'Move Up
    If JI.dwYpos < 32000 Then
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        DirUp = True
        DirDown = False
        DirLeft = False
        DirRight = False
        Exit Sub
    Else
        DirUp = False
    End If
    
    'Move Right
    If JI.dwXpos > 33000 Then
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        DirUp = False
        DirDown = False
        DirLeft = False
        DirRight = True
        Exit Sub
    Else
        DirRight = False
    End If
    
    'Move down
    If JI.dwYpos > 33000 Then
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        DirUp = False
        DirDown = True
        DirLeft = False
        DirRight = False
        Exit Sub
    Else
        DirDown = False
    End If
    
    'Move left
    If JI.dwXpos < 32000 Then
        If frmMainGame.picGUI.Visible = True Then Exit Sub
        DirUp = False
        DirDown = False
        DirLeft = True
        DirRight = False
        Exit Sub
    Else
        DirLeft = False
    End If
    
End Sub

Public Sub CheckMenuKeys()
Dim maxIndex As Long, I As Long

    If frmMainMenu.WindowState = vbMinimized Then Exit Sub
    
    ''''''''''''''''''''''''''''''''''''''''''' Joypad
    
    ' Joypad keypresses
    If joyGetPosEx(JNum, JI) <> 0 Then Exit Sub
    
    If JI.dwButtons = 2 Then ' B button
        With frmMainMenu
            If .mnuChars.Visible = True Then
                .mnuChars.Visible = False
            ElseIf .mnuCredits.Visible = True Then
                .mnuCredits.Visible = False
            ElseIf .mnuIPConfig.Visible = True Then
                .mnuIPConfig.Visible = False
            ElseIf .mnuLogin.Visible = True Then
                .mnuLogin.Visible = False
            ElseIf .mnuNewAccount.Visible = True Then
                .mnuNewAccount.Visible = False
            ElseIf .mnuNewCharacter.Visible = True Then
                .mnuNewCharacter.Visible = False
            Else ' Main Menu
                
            End If
        End With
    End If
    
    If JI.dwButtons = 1 Then ' A button
        With frmMainMenu
            If .mnuChars.Visible = True Then
                
            ElseIf .mnuCredits.Visible = True Then
            
            ElseIf .mnuIPConfig.Visible = True Then
            
            ElseIf .mnuLogin.Visible = True Then
            
            ElseIf .mnuNewAccount.Visible = True Then
            
            ElseIf .mnuNewCharacter.Visible = True Then
            
            Else ' Main Menu
                Select Case btnIndex
                    Case 0
                        .mnuNewAccount.Visible = True
                        .txtNewAcctName.SetFocus
                        
                        Exit Sub
                    Case 1
                        If GameData.SaveLogin = 1 Then
                            .chkLogin.Value = 1
                            .txtLoginName.Text = Trim$(GameData.Username)
                            .txtLoginPassword.Text = Trim$(GameData.Password)
                        End If
                        
                        .mnuLogin.Visible = True
                        .txtLoginName.SetFocus
                        
                        Exit Sub
                    Case 2
                        .txtIP.Text = Trim$(GameData.IP)
                        .txtPort.Text = Trim$(GameData.Port)
                        .mnuIPConfig.Visible = True
                        
                        .txtIP.SetFocus
                        
                        Exit Sub
                    Case 3
                        ' Game Options Here
                        
                        Exit Sub
                    Case 4
                        Call DestroyGame
                        
                        Exit Sub
                    Case 5
                        .mnuCredits.Visible = True
                        
                        Exit Sub
                End Select
            End If
        End With
    End If
    
    If (JI.dwPOV / 100) = 0 And btnPOVDown = False Then ' Up
        With frmMainMenu
            If .mnuChars.Visible = True Then
                maxIndex = .lblChars.UBound
                If btnIndex <= 0 Then
                    btnIndex = maxIndex
                    For I = .lblChars.LBound To .lblChars.UBound
                        .lblChars(I).FontBold = False
                    Next I
                    .lblChars(btnIndex).FontBold = True
                Else
                    btnIndex = btnIndex - 1
                    For I = .lblChars.LBound To .lblChars.UBound
                        .lblChars(I).FontBold = False
                    Next I
                    .lblChars(btnIndex).FontBold = True
                End If
                
            ElseIf .mnuCredits.Visible = True Then
            
            ElseIf .mnuIPConfig.Visible = True Then
                maxIndex = .lblIPConfig.UBound
                If btnIndex <= 0 Then
                    btnIndex = maxIndex
                    For I = .lblIPConfig.LBound To .lblIPConfig.UBound
                        .lblIPConfig(I).FontBold = False
                    Next I
                    .lblIPConfig(btnIndex).FontBold = True
                Else
                    btnIndex = btnIndex - 1
                    For I = .lblIPConfig.LBound To .lblIPConfig.UBound
                        .lblIPConfig(I).FontBold = False
                    Next I
                    .lblIPConfig(btnIndex).FontBold = True
                End If
            
            ElseIf .mnuLogin.Visible = True Then
                maxIndex = .lblLogin.UBound
                If btnIndex <= 0 Then
                    btnIndex = maxIndex
                    For I = .lblLogin.LBound To .lblLogin.UBound
                        .lblLogin(I).FontBold = False
                    Next I
                    .lblLogin(btnIndex).FontBold = True
                Else
                    btnIndex = btnIndex - 1
                    For I = .lblLogin.LBound To .lblLogin.UBound
                        .lblLogin(I).FontBold = False
                    Next I
                    .lblLogin(btnIndex).FontBold = True
                End If
                
            ElseIf .mnuNewAccount.Visible = True Then
                maxIndex = .lblConnect.UBound
                If btnIndex <= 0 Then
                    btnIndex = maxIndex
                    For I = .lblConnect.LBound To .lblConnect.UBound
                        .lblConnect(I).FontBold = False
                    Next I
                    .lblConnect(btnIndex).FontBold = True
                Else
                    btnIndex = btnIndex - 1
                    For I = .lblConnect.LBound To .lblConnect.UBound
                        .lblConnect(I).FontBold = False
                    Next I
                    .lblConnect(btnIndex).FontBold = True
                End If
            
            ElseIf .mnuNewCharacter.Visible = True Then
                maxIndex = .lblNewChar.UBound
                If btnIndex <= 0 Then
                    btnIndex = maxIndex
                    For I = .lblNewChar.LBound To .lblNewChar.UBound
                        .lblNewChar(I).FontBold = False
                    Next I
                    .lblNewChar(btnIndex).FontBold = True
                Else
                    btnIndex = btnIndex - 1
                    For I = .lblNewChar.LBound To .lblNewChar.UBound
                        .lblNewChar(I).FontBold = False
                    Next I
                    .lblNewChar(btnIndex).FontBold = True
                End If
            
            Else ' Main Menu
                maxIndex = .lblMainMenu.UBound
                If btnIndex <= 0 Then
                    btnIndex = maxIndex
                    For I = .lblMainMenu.LBound To .lblMainMenu.UBound
                        .lblMainMenu(I).FontBold = False
                    Next I
                    .lblMainMenu(btnIndex).FontBold = True
                Else
                    btnIndex = btnIndex - 1
                    For I = .lblMainMenu.LBound To .lblMainMenu.UBound
                        .lblMainMenu(I).FontBold = False
                    Next I
                    .lblMainMenu(btnIndex).FontBold = True
                End If
            End If
        End With
        btnPOVDown = True
    End If
    
    If (JI.dwPOV / 100) = 180 And btnPOVDown = False Then ' Down
        With frmMainMenu
            If .mnuChars.Visible = True Then
                
            ElseIf .mnuCredits.Visible = True Then
            
            ElseIf .mnuIPConfig.Visible = True Then
            
            ElseIf .mnuLogin.Visible = True Then
            
            ElseIf .mnuNewAccount.Visible = True Then
            
            ElseIf .mnuNewCharacter.Visible = True Then
            
            Else ' Main Menu
                maxIndex = .lblMainMenu.UBound
                If btnIndex >= maxIndex Then
                    btnIndex = 0
                    For I = .lblMainMenu.LBound To .lblMainMenu.UBound
                        .lblMainMenu(I).FontBold = False
                    Next I
                    .lblMainMenu(btnIndex).FontBold = True
                Else
                    btnIndex = btnIndex + 1
                    For I = .lblMainMenu.LBound To .lblMainMenu.UBound
                        .lblMainMenu(I).FontBold = False
                    Next I
                    .lblMainMenu(btnIndex).FontBold = True
                End If
            End If
        End With
        btnPOVDown = True
    End If
    
    'Reset POV status
    If JI.dwPOV = 65535 Then
        btnPOVDown = False
    End If
    
    'Reset Pad Button status
    If JI.dwButtons = 0 Then
        btnPadDown = False
    End If
End Sub

Public Sub CheckStartMenuKeys()
Dim maxIndex As Long, I As Long
Dim Buffer As clsBuffer

    If frmMainGame.WindowState = vbMinimized Then Exit Sub
    If frmMainGame.picGUI.Visible = False Then Exit Sub
    
    ''''''''''''''''''''''''''''''''''''''''''' Joypad
    
    ' Joypad keypresses
    If joyGetPosEx(JNum, JI) <> 0 Then Exit Sub
    
    If JI.dwButtons = 1 And btnPOVDown = False Then ' A button
        Select Case btnIndex
            Case 0
                Call UpdateInventory
                frmMainGame.picInvList.Visible = (Not frmMainGame.picInvList.Visible)
                frmMainGame.picGUI.Visible = False
            Case 1
                Set Buffer = New clsBuffer
                
                If frmMainGame.picSpellsList.Visible Then
                    frmMainGame.picSpellsList.Visible = False
                Else
                    Buffer.PreAllocate 2
                    Buffer.WriteInteger CSpells
                    Call SendData(Buffer.ToArray())
                End If
                frmMainGame.picGUI.Visible = False
            Case 2
                Set Buffer = New clsBuffer
                
                Buffer.PreAllocate 2
                Buffer.WriteInteger CGetStats
                Call SendData(Buffer.ToArray())
                frmMainGame.picGUI.Visible = False
            Case 3
                frmTraining.Show vbModal
                frmMainGame.picGUI.Visible = False
            Case 4
                Set Buffer = New clsBuffer
                
                Buffer.PreAllocate 2
                Buffer.WriteInteger CTrade
                Call SendData(Buffer.ToArray())
                frmMainGame.picGUI.Visible = False
            Case 5
                Set Buffer = New clsBuffer
                
                Buffer.PreAllocate 2
                Buffer.WriteInteger CQuit
                
                isLogging = True
                InGame = False
                Stop_Music
                Call SendData(Buffer.ToArray())
                Call DestroyTCP
                Call DestroyGame
        End Select
        btnPOVDown = True
    End If
    
    If (JI.dwPOV / 100) = 0 And btnPOVDown = False Then ' Up
        With frmMainGame
            If .picGUI.Visible = True Then
                maxIndex = .lblStartMenu.UBound
                If btnIndex <= 0 Then
                    btnIndex = maxIndex
                    For I = .lblStartMenu.LBound To .lblStartMenu.UBound
                        .lblStartMenu(I).FontBold = False
                    Next I
                    .lblStartMenu(btnIndex).FontBold = True
                Else
                    btnIndex = btnIndex - 1
                    For I = .lblStartMenu.LBound To .lblStartMenu.UBound
                        .lblStartMenu(I).FontBold = False
                    Next I
                    .lblStartMenu(btnIndex).FontBold = True
                End If
            End If
        End With
        btnPOVDown = True
    End If
    
    If (JI.dwPOV / 100) = 180 And btnPOVDown = False Then ' Down
        With frmMainGame
            If .picGUI.Visible = True Then
                maxIndex = .lblStartMenu.UBound
                If btnIndex >= maxIndex Then
                    btnIndex = 0
                    For I = .lblStartMenu.LBound To .lblStartMenu.UBound
                        .lblStartMenu(I).FontBold = False
                    Next I
                    .lblStartMenu(btnIndex).FontBold = True
                Else
                    btnIndex = btnIndex + 1
                    For I = .lblStartMenu.LBound To .lblStartMenu.UBound
                        .lblStartMenu(I).FontBold = False
                    Next I
                    .lblStartMenu(btnIndex).FontBold = True
                End If
            End If
        End With
        btnPOVDown = True
    End If
    
    'Reset POV status
    If JI.dwPOV = 65535 Then
        btnPOVDown = False
    End If
    
    'Reset Pad Button status
    If JI.dwButtons = 0 Then
        btnPadDown = False
    End If
End Sub

Private Sub CheckMapGetItem()
    Dim Buffer As clsBuffer
    If GetTickCount > Player(MyIndex).MapGetTimer + 250 Then
        If Trim$(MyText) = vbNullString Then
            Set Buffer = New clsBuffer
            Buffer.PreAllocate 2
            Buffer.WriteInteger CMapGetItem
            Player(MyIndex).MapGetTimer = GetTickCount
            Call SendData(Buffer.ToArray())
        End If
    End If
End Sub

' Processes input from player
Public Sub HandleKeyPresses(ByVal KeyAscii As Integer)
    Dim ChatText As String
    Dim name As String
    Dim I As Long
    Dim n As Long
    Dim Command() As String
    Dim Buffer As clsBuffer
    
    ChatText = Trim$(MyText)
    
    If LenB(ChatText) = 0 Then Exit Sub
    
    MyText = LCase$(ChatText)
    
    ' Handle when the player presses the return key
    If KeyAscii = vbKeyReturn Then
        
        ' Broadcast message
        If Left$(ChatText, 1) = "'" Then
            ChatText = Mid$(ChatText, 2, Len(ChatText) - 1)
            If Len(ChatText) > 0 Then
                Call BroadcastMsg(ChatText)
            End If
            MyText = vbNullString
            frmMainGame.txtMyChat.Text = vbNullString
            Exit Sub
        End If
        
        ' Emote message
        If Left$(ChatText, 1) = "-" Then
            MyText = Mid$(ChatText, 2, Len(ChatText) - 1)
            If Len(ChatText) > 0 Then
                Call EmoteMsg(ChatText)
            End If
            MyText = vbNullString
            frmMainGame.txtMyChat.Text = vbNullString
            Exit Sub
        End If
        
        ' Player message
        If Left$(ChatText, 1) = "!" Then
            ChatText = Mid$(ChatText, 2, Len(ChatText) - 1)
            name = vbNullString
            
            ' Get the desired player from the user text
            For I = 1 To Len(ChatText)
                If Mid$(ChatText, I, 1) <> Space(1) Then
                    name = name & Mid$(ChatText, I, 1)
                Else
                    Exit For
                End If
            Next
            
            ChatText = Mid$(ChatText, I, Len(ChatText) - 1)
            
            ' Make sure they are actually sending something
            If Len(ChatText) - I > 0 Then
                MyText = Mid$(ChatText, I + 1, Len(ChatText) - I)
                
                ' Send the message to the player
                Call PlayerMsg(ChatText, name)
            Else
                Call AddText("Usage: !playername (message)", AlertColor)
            End If
            MyText = vbNullString
            frmMainGame.txtMyChat.Text = vbNullString
            Exit Sub
        End If
        
        ' Global Message
        If Left$(ChatText, 1) = vbQuote Then
            If GetPlayerAccess(MyIndex) >= ADMIN_MAPPER Then
                ChatText = Mid$(ChatText, 2, Len(ChatText) - 1)
                If Len(ChatText) > 0 Then
                    Call GlobalMsg(ChatText)
                End If
                MyText = vbNullString
                frmMainGame.txtMyChat.Text = vbNullString
                Exit Sub
            End If
        End If
        
        ' Admin Message
        If Left$(ChatText, 1) = "=" Then
            If GetPlayerAccess(MyIndex) >= ADMIN_MAPPER Then
                ChatText = Mid$(ChatText, 2, Len(ChatText) - 1)
                If Len(ChatText) > 0 Then
                    Call AdminMsg(ChatText)
                End If
                MyText = vbNullString
                frmMainGame.txtMyChat.Text = vbNullString
                Exit Sub
            End If
        End If
        
        If Left$(MyText, 1) = "/" Then
            Command = Split(MyText, Space(1))
            
            Select Case Command(0)
            Case "/help"
                Call AddText("Social Commands:", HelpColor)
                Call AddText("'msghere = Broadcast Message", HelpColor)
                Call AddText("-msghere = Emote Message", HelpColor)
                Call AddText("!namehere msghere = Player Message", HelpColor)
                Call AddText("Available Commands: /help, /info, /who, /fps, /inv, /stats, /train, /trade, /party, /join, /leave, /resetui", HelpColor)
            Case "/purgegraphics"
                GameData.VerProcess = -1
                
                Dim filename As String
                
                filename = App.Path & DATA_PATH & "config.dat"
                
                Dim F As Long
                F = FreeFile
                Open filename For Binary As #F
                Put #F, , GameData
                Close #F
                
            Case "/info"
                ' Checks to make sure we have more than one string in the array
                If UBound(Command) < 1 Then
                    AddText "Usage: /info (name)", AlertColor
                    GoTo Continue
                End If
                
                If IsNumeric(Command(1)) Then
                    AddText "Usage: /info (name)", AlertColor
                    GoTo Continue
                End If
                Set Buffer = New clsBuffer
                Buffer.PreAllocate Len(Command(1)) + 4
                Buffer.WriteInteger CPlayerInfoRequest
                Buffer.WriteString Command(1)
                Call SendData(Buffer.ToArray())
                
                ' Whos Online
            Case "/who"
                SendWhosOnline
                
                ' Checking fps
            Case "/fps"
                BFPS = Not BFPS
                
            Case "/guildinvite"
                If UBound(Command) < 1 Then
                    AddText "Usage: /guildinvite (name)", AlertColor
                    GoTo Continue
                End If
                
                SendGuildInvite Command(1)
                
            Case "/guildkick"
                If UBound(Command) < 1 Then
                    AddText "Usage: /guildkick (name)", AlertColor
                    GoTo Continue
                End If
                
                SendGuildKick Command(1)
                
            Case "/guildpromote"
                If UBound(Command) < 2 Then
                    AddText "Usage: /guildkick (name) (access)", AlertColor
                    GoTo Continue
                End If
                
                If IsNumeric(Val(Command(2))) = False Then
                    AddText "Usage: /guildkick (name) (access)", AlertColor
                    GoTo Continue
                End If
                
                SendGuildPromote Command(1), Val(Command(2))
                ' Show inventory
            Case "/inv"
                UpdateInventory
                frmMainGame.picInvList.Visible = (Not frmMainGame.picInvList.Visible)
                
                ' Request stats
            Case "/stats"
                Set Buffer = New clsBuffer
                Buffer.PreAllocate 2
                Buffer.WriteInteger CGetStats
                SendData Buffer.ToArray()
                
                ' Show training
            Case "/train"
                frmTraining.Show vbModal
                
                ' Request stats
            Case "/trade"
                Set Buffer = New clsBuffer
                Buffer.PreAllocate 2
                Buffer.WriteInteger CTrade
                SendData Buffer.ToArray()
                
                ' Party request
            Case "/party"
                ' Make sure they are actually sending something
                If UBound(Command) < 1 Then
                    AddText "Usage: /party (name)", AlertColor
                    GoTo Continue
                End If
                
                If IsNumeric(Command(1)) Then
                    AddText "Usage: /party (name)", AlertColor
                    GoTo Continue
                End If
                
                Call SendPartyRequest(Command(1))
                
                ' Join party
            Case "/join"
                SendJoinParty
                
                ' Leave party
            Case "/leave"
                SendLeaveParty
                
            Case "/resetui"
                Call ResetUI
                
                ' // Monitor Admin Commands //
                ' Admin Help
            Case "/admin"
                If GetPlayerAccess(MyIndex) < ADMIN_MONITOR Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                Call AddText("Social Commands:", HelpColor)
                Call AddText("""msghere = Global Admin Message", HelpColor)
                Call AddText("=msghere = Private Admin Message", HelpColor)
                Call AddText("Available Commands: /admin, /loc, /mapeditor, /warpmeto, /warptome, /warpto, /setsprite, /mapreport, /kick, /ban, /edititem, /respawn, /editnpc, /motd, /editshop, /editspell, /debug", HelpColor)
                
                ' Kicking a player
            Case "/kick"
                If GetPlayerAccess(MyIndex) < ADMIN_MONITOR Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                If UBound(Command) < 1 Then
                    AddText "Usage: /kick (name)", AlertColor
                    GoTo Continue
                End If
                
                If IsNumeric(Command(1)) Then
                    AddText "Usage: /kick (name)", AlertColor
                    GoTo Continue
                End If
                
                SendKick Command(1)
                
                ' // Mapper Admin Commands //
                ' Location
            Case "/loc"
                If GetPlayerAccess(MyIndex) < ADMIN_MAPPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                BLoc = Not BLoc
                
                ' Map Editor
            Case "/mapeditor"
                If GetPlayerAccess(MyIndex) < ADMIN_MAPPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                SendRequestEditMap
                
                ' Warping to a player
            Case "/warpmeto"
                If GetPlayerAccess(MyIndex) < ADMIN_MAPPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                If UBound(Command) < 1 Then
                    AddText "Usage: /warpmeto (name)", AlertColor
                    GoTo Continue
                End If
                
                If IsNumeric(Command(1)) Then
                    AddText "Usage: /warpmeto (name)", AlertColor
                    GoTo Continue
                End If
                
                WarpMeTo Command(1)
                
                ' Warping a player to you
            Case "/warptome"
                If GetPlayerAccess(MyIndex) < ADMIN_MAPPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                If UBound(Command) < 1 Then
                    AddText "Usage: /warptome (name)", AlertColor
                    GoTo Continue
                End If
                
                If IsNumeric(Command(1)) Then
                    AddText "Usage: /warptome (name)", AlertColor
                    GoTo Continue
                End If
                
                WarpToMe Command(1)
                
                ' Warping to a map
            Case "/warpto"
                If GetPlayerAccess(MyIndex) < ADMIN_MAPPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                If UBound(Command) < 1 Then
                    AddText "Usage: /warpto (map #)", AlertColor
                    GoTo Continue
                End If
                
                If Not IsNumeric(Command(1)) Then
                    AddText "Usage: /warpto (map #)", AlertColor
                    GoTo Continue
                End If
                
                n = CLng(Command(1))
                
                ' Check to make sure its a valid map #
                If n > 0 And n <= MAX_MAPS Then
                    Call WarpTo(n)
                Else
                    Call AddText("Invalid map number.", Red)
                End If
                
                ' Setting sprite
            Case "/setsprite"
                If GetPlayerAccess(MyIndex) < ADMIN_MAPPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                If UBound(Command) < 1 Then
                    AddText "Usage: /setsprite (sprite #)", AlertColor
                    GoTo Continue
                End If
                
                If Not IsNumeric(Command(1)) Then
                    AddText "Usage: /setsprite (sprite #)", AlertColor
                    GoTo Continue
                End If
                
                SendSetSprite CLng(Command(1))
                
                ' Map report
            Case "/mapreport"
                If GetPlayerAccess(MyIndex) < ADMIN_MAPPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                Set Buffer = New clsBuffer
                Buffer.PreAllocate 2
                Buffer.WriteInteger CMapReport
                SendData Buffer.ToArray()
                
                ' Respawn request
            Case "/respawn"
                If GetPlayerAccess(MyIndex) < ADMIN_MAPPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                SendMapRespawn
                
                ' MOTD change
            Case "/motd"
                If GetPlayerAccess(MyIndex) < ADMIN_MAPPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                If UBound(Command) < 1 Then
                    AddText "Usage: /motd (new motd)", AlertColor
                    GoTo Continue
                End If
                
                SendMOTDChange Right$(ChatText, Len(ChatText) - 5)
                
                ' Check the ban list
            Case "/banlist"
                If GetPlayerAccess(MyIndex) < ADMIN_MAPPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                SendBanList
                
                ' Banning a player
            Case "/ban"
                If GetPlayerAccess(MyIndex) < ADMIN_MAPPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                If UBound(Command) < 1 Then
                    AddText "Usage: /ban (name)", AlertColor
                    GoTo Continue
                End If
                
                SendBan Command(1)
                
                ' // Developer Admin Commands //
                ' Editing item request
            Case "/edititem"
                If GetPlayerAccess(MyIndex) < ADMIN_DEVELOPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                SendRequestEditItem
                
                ' Editing npc request
            Case "/editnpc"
                If GetPlayerAccess(MyIndex) < ADMIN_DEVELOPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                SendRequestEditNpc
                
                ' Editing shop request
            Case "/editshop"
                If GetPlayerAccess(MyIndex) < ADMIN_DEVELOPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                SendRequestEditShop
                
                ' Editing spell request
            Case "/editspell"
                If GetPlayerAccess(MyIndex) < ADMIN_DEVELOPER Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                SendRequestEditSpell
                
                ' // Creator Admin Commands //
            Case "/createguild"
                If GetPlayerAccess(MyIndex) < ADMIN_CREATOR Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                
                If UBound(Command) < 2 Then
                    AddText "Usage: /createguild (user) (guild)", AlertColor
                    GoTo Continue
                End If
                
                SendCreateGuild Command(1), Command(2)
                
            Case "/removefromguild"
                If GetPlayerAccess(MyIndex) < ADMIN_CREATOR Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                
                If UBound(Command) < 2 Then
                    AddText "Usage: /removefromguild (user) (guild)", AlertColor
                    GoTo Continue
                End If
                
                SendRemoveFromGuild Command(1), Command(2)
                
                ' Giving another player access
            Case "/setaccess"
                If GetPlayerAccess(MyIndex) < ADMIN_CREATOR Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                
                If UBound(Command) < 2 Then
                    AddText "Usage: /setaccess (name) (access)", AlertColor
                    GoTo Continue
                End If
                
                If IsNumeric(Command(1)) Or Not IsNumeric(Command(2)) Then
                    AddText "Usage: /setaccess (name) (access)", AlertColor
                    GoTo Continue
                End If
                
                SendSetAccess Command(1), CLng(Command(2))
                
                ' Ban destroy
            Case "/destroybanlist"
                If GetPlayerAccess(MyIndex) < ADMIN_CREATOR Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                SendBanDestroy
                
                ' Packet debug mode
            Case "/debug"
                If GetPlayerAccess(MyIndex) < ADMIN_CREATOR Then
                    AddText "You need to be a high enough staff member to do this!", AlertColor
                    GoTo Continue
                End If
                
                DebugMode = (Not DebugMode)
                
            Case Else
                AddText "Not a valid command!", HelpColor
                
            End Select
            
            'continue label where we go instead of exiting the sub
Continue:
            
            MyText = vbNullString
            frmMainGame.txtMyChat.Text = vbNullString
            Exit Sub
        End If
        
        ' And if neither, then add the character to the user's text buffer
        'If (KeyAscii <> vbKeyReturn) Then
        '    If (KeyAscii <> vbKeyBack) Then
        '
        '        ' Make sure the character is on standard English keyboard
        '        If KeyAscii >= 32 Then ' Asc(" ")
        '            If KeyAscii <= 126 Then ' Asc("~")
        '                MyText = MyText & ChrW$(KeyAscii)
        '            End If
        '        End If
        '
        '    End If
        'End If
        
        ' Handle when the user presses the backspace key
        'If (KeyAscii = vbKeyBack) Then
        '    If LenB(MyText) > 0 Then MyText = Mid$(MyText, 1, Len(MyText) - 1)
        'End If
        
        ' Say message
        If Len(ChatText) > 0 Then
            Call SayMsg(ChatText)
        End If
        
        MyText = vbNullString
        frmMainGame.txtMyChat.Text = vbNullString
        Exit Sub
    End If
    
    
End Sub

