Attribute VB_Name = "modDatabase"
'*****************************************
'**       MADE WITH MIRAGE ENGINE       **
'**        Maintained by Xlithan        **
'*****************************************
Option Explicit

' Text API
Private Declare Function WritePrivateProfileString Lib "kernel32.dll" Alias "WritePrivateProfileStringA" (ByVal lpApplicationname As String, ByVal lpKeyname As Any, ByVal lpString As String, ByVal lpfilename As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32.dll" Alias "GetPrivateProfileStringA" (ByVal lpApplicationname As String, ByVal lpKeyname As Any, ByVal lpdefault As String, ByVal lpreturnedstring As String, ByVal nsize As Long, ByVal lpfilename As String) As Long

'For Clear functions
Private Declare Sub ZeroMemory Lib "kernel32.dll" Alias "RtlZeroMemory" (Destination As Any, ByVal Length As Long)

Public ServerLog As Boolean ' Used for logging

Public Function FileExist(ByVal FileName As String, Optional RAW As Boolean = False) As Boolean
    If Not RAW Then
        If LenB(Dir(App.Path & "\" & FileName)) > 0 Then
            FileExist = True
        End If
    Else
        If LenB(Dir(FileName)) > 0 Then
            FileExist = True
        End If
    End If
End Function

Public Sub AddLog(ByVal Text As String, ByVal FN As String)
    Dim FileName As String
    Dim F As Integer
    
    If ServerLog Then
        FileName = App.Path & "\logs\" & FN
        
        If Not FileExist(FileName, True) Then
            F = FreeFile
            Open FileName For Output As #F
            Close #F
        End If
        
        F = FreeFile
        Open FileName For Append As #F
        Print #F, time & ": " & Text
        Close #F
    End If
End Sub

Public Function GetVar(File As String, Header As String, Var As String) As String
    Dim sSpaces As String   ' Max string length
    Dim szReturn As String  ' Return default value if not found
    
    szReturn = vbNullString
    
    sSpaces = Space$(5000)
    
    Call GetPrivateProfileString$(Header, Var, szReturn, sSpaces, Len(sSpaces), File)
    
    GetVar = RTrim$(sSpaces)
    GetVar = Left$(GetVar, Len(GetVar) - 1)
End Function

Public Sub PutVar(File As String, Header As String, Var As String, value As String)
    Call WritePrivateProfileString$(Header, Var, value, File)
End Sub

Public Sub BanIndex(ByVal BanPlayerIndex As Long, ByVal BannedByIndex As Long)
    Dim FileName As String
    Dim IP As String
    Dim F As Long
    Dim I As Long
    
    FileName = App.Path & "\data\banlist.txt"
    
    ' Make sure the file exists
    If Not FileExist("data\banlist.txt") Then
        F = FreeFile
        Open FileName For Output As #F
        Close #F
    End If
    
    ' Cut off last portion of ip
    IP = GetPlayerIP(BanPlayerIndex)
    
    For I = Len(IP) To 1 Step -1
        If Mid$(IP, I, 1) = "." Then
            Exit For
        End If
    Next
    IP = Mid$(IP, 1, I)
    
    F = FreeFile
    Open FileName For Append As #F
    Print #F, IP & "," & GetPlayerName(BannedByIndex)
    Close #F
    
    Call GlobalMsg(GetPlayerName(BanPlayerIndex) & " has been banned from " & GAME_NAME & " by " & GetPlayerName(BannedByIndex) & "!", White)
    Call AddLog(GetPlayerName(BannedByIndex) & " has banned " & GetPlayerName(BanPlayerIndex) & ".", ADMIN_LOG)
    Call AlertMsg(BanPlayerIndex, "You have been banned by " & GetPlayerName(BannedByIndex) & "!")
End Sub

Public Sub ServerBanIndex(ByVal BanPlayerIndex As Long)
    Dim FileName As String
    Dim IP As String
    Dim F As Long
    Dim I As Long
    
    FileName = App.Path & "\data\banlist.txt"
    
    ' Make sure the file exists
    If Not FileExist("data\banlist.txt") Then
        F = FreeFile
        Open FileName For Output As #F
        Close #F
    End If
    
    ' Cut off last portion of ip
    IP = GetPlayerIP(BanPlayerIndex)
    
    For I = Len(IP) To 1 Step -1
        
        If Mid$(IP, I, 1) = "." Then
            Exit For
        End If
        
    Next
    
    IP = Mid$(IP, 1, I)
    
    F = FreeFile
    Open FileName For Append As #F
    Print #F, IP & ", Server"
    Close #F
    
    Call GlobalMsg(GetPlayerName(BanPlayerIndex) & " has been banned from " & GAME_NAME & " by the Server!", White)
    Call AddLog("The Server has banned " & GetPlayerName(BanPlayerIndex) & ".", ADMIN_LOG)
    Call AlertMsg(BanPlayerIndex, "You have been banned by The Server!")
End Sub

' **************
' ** Accounts **
' **************
Public Function AccountExist(ByVal Name As String) As Boolean
Dim cLogin As String
Dim iExist As Boolean
Dim rs As ADODB.Recordset, objCommand As ADODB.Command

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "SELECT * FROM accounts WHERE `Login`= ?;"
        .Prepared = True
        
        .Parameters.Append .CreateParameter("login", adVarChar, adParamInput, ACCOUNT_LENGTH, Trim$(Name))
        
        Set rs = .Execute
    End With
    
    iExist = False
    If Not (rs.BOF And rs.EOF) Then
        iExist = True
    Else
        iExist = False
    End If
    rs.Close
    AccountExist = iExist
    
    Set rs = Nothing
    Set objCommand = Nothing
End Function

Public Function PasswordOK(ByVal Name As String, ByVal Password As String) As Boolean
Dim iExist As Boolean
Dim rs As ADODB.Recordset, objCommand As ADODB.Command

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "SELECT * FROM accounts WHERE `Login`= ? AND `Password`= ?;"
        .Prepared = True
        
        .Parameters.Append .CreateParameter("login", adVarChar, adParamInput, ACCOUNT_LENGTH, Trim$(Name))
        .Parameters.Append .CreateParameter("login", adVarChar, adParamInput, PASS_LENGTH, Trim$(Password))
        
        Set rs = .Execute
    End With
    
    iExist = False
    If Not (rs.BOF And rs.EOF) Then
        iExist = True
    Else
        iExist = False
    End If
    rs.Close
    
    Set rs = Nothing
    Set objCommand = Nothing
    PasswordOK = iExist
End Function

Public Sub AddAccount(ByVal Index As Long, ByVal Name As String, ByVal Password As String)
Dim I As Long
    
    ClearPlayer Index
    
    Player(Index).Login = Name
    Player(Index).Password = Password

    Call SaveNewAccount(Index)
End Sub

'Public Sub DeleteName(ByVal Name As String)
'    Dim f1 As Long
'    Dim f2 As Long
'    Dim S As String
'
'    Call FileCopy(App.Path & "\accounts\charlist.txt", App.Path & "\accounts\chartemp.txt")
'
'    ' Destroy name from charlist
'    f1 = FreeFile
'    Open App.Path & "\accounts\chartemp.txt" For Input As #f1
'
'    f2 = FreeFile
'    Open App.Path & "\accounts\charlist.txt" For Output As #f2
'
'    Do While Not EOF(f1)
'        Input #f1, S
'        If Trim$(LCase$(S)) <> Trim$(LCase$(Name)) Then
'            Print #f2, S
'        End If
'    Loop
'
'    Close #f1
'
'    Close #f2
'
'    Call Kill(App.Path & "\accounts\chartemp.txt")
'End Sub

' ****************
' ** Characters **
' ****************

Public Function CharExist(ByVal Index As Long, ByVal CharNum As Long) As Boolean
    If LenB(Trim$(Player(Index).Char(CharNum).Name)) > 0 Then
        CharExist = True
    End If
End Function

Public Sub AddChar(ByVal Index As Long, ByVal Name As String, ByVal Sex As Byte, ByVal ClassNum As Byte, ByVal CharNum As Long)
    Dim F As Long
    Dim n As Long
    
    If LenB(Trim$(Player(Index).Char(CharNum).Name)) = 0 Then
        TempPlayer(Index).CharNum = CharNum
        
        Player(Index).Char(CharNum).Name = Name
        Player(Index).Char(CharNum).Sex = Sex
        Player(Index).Char(CharNum).Class = ClassNum
        
        If Player(Index).Char(CharNum).Sex = SEX_MALE Then
            Player(Index).Char(CharNum).Sprite = Class(ClassNum).Sprite
        Else
            Player(Index).Char(CharNum).Sprite = Class(ClassNum).Sprite
        End If
        
        Player(Index).Char(CharNum).Level = 1
        
        For n = 1 To Stats.Stat_Count - 1
            Player(Index).Char(CharNum).Stat(n) = Class(ClassNum).Stat(n)
        Next n
        
        Player(Index).Char(CharNum).Map = START_MAP
        Player(Index).Char(CharNum).X = START_X
        Player(Index).Char(CharNum).Y = START_Y
        
        Player(Index).Char(CharNum).Vital(Vitals.HP) = GetPlayerMaxVital(Index, Vitals.HP)
        Player(Index).Char(CharNum).Vital(Vitals.MP) = GetPlayerMaxVital(Index, Vitals.MP)
        Player(Index).Char(CharNum).Vital(Vitals.SP) = GetPlayerMaxVital(Index, Vitals.SP)
        
        Call SaveNewChar(Index)
        
        Exit Sub
    End If
End Sub

Public Function FindChar(ByVal Name As String) As Boolean
Dim iExist As Boolean
Dim rs As ADODB.Recordset, objCommand As ADODB.Command

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "SELECT * FROM characters WHERE `Name`= ?;"
        .Prepared = True
        
        .Parameters.Append .CreateParameter("name", adVarChar, adParamInput, NAME_LENGTH, Trim$(Name))
        
        Set rs = .Execute
    End With
    
    iExist = False
    If Not (rs.BOF And rs.EOF) Then
        iExist = True
    Else
        iExist = False
    End If
    rs.Close
    Set rs = Nothing
    Set objCommand = Nothing
    FindChar = iExist
End Function

' *************
' ** Players **
' *************

Public Sub SaveAllPlayersOnline()
    Dim I As Long
    
    For I = 1 To TotalPlayersOnline
        Call SavePlayer(PlayersOnline(I))
    Next
End Sub

Sub SaveNewChar(ByVal Index As Long)
Dim rs As ADODB.Recordset, objCommand As ADODB.Command
Dim I As Long, X As Long, Y As Long, n As Long
Dim SPELLString As String, INVString As String

    'Do Characters
    INVString = ""
    SPELLString = ""
    
    With Player(Index).Char(TempPlayer(Index).CharNum)
        'Inventory
        For X = 1 To MAX_INV
            INVString = INVString & .Inv(X).Num & "-"
            INVString = INVString & .Inv(X).value & "|"
        Next X
    
        'Spells
        For X = 1 To MAX_PLAYER_SPELLS
            If X <> MAX_PLAYER_SPELLS Then
                SPELLString = SPELLString & .Spell(X) & "-"
            Else
                SPELLString = SPELLString & .Spell(X)
            End If
        Next X
    End With
    
    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "INSERT INTO `characters` (" & _
                        "`Account`, `Name`, `Sex`, `Class`, `Sprite`, `Level`, " & _
                        "`Guild`, `GuildAccess`, " & _
                        "`Exp`, `Access`, `PK`, " & _
                        "`Map`, `X`, `Y`, `Dir`, " & _
                        "`HP`, `MP`, `SP`, " & _
                        "`STR`, `DEF`, `SPE`, `MAGI`, `POINTS`, " & _
                        "`WeaponSlot`, `ArmorSlot`, `HelmetSlot`, `ShieldSlot`, " & _
                        "`Inventory`, `Spells`)" & _
                        "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)"
        .Prepared = True
        
        .Parameters.Append .CreateParameter("account", adInteger, adParamInput, , Player(Index).SQLID)
        .Parameters.Append .CreateParameter("name", adVarChar, adParamInput, NAME_LENGTH, Trim$(Player(Index).Char(TempPlayer(Index).CharNum).Name))
        .Parameters.Append .CreateParameter("sex", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Sex)
        .Parameters.Append .CreateParameter("class", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Class)
        .Parameters.Append .CreateParameter("sprite", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Sprite)
        .Parameters.Append .CreateParameter("level", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Level)
        .Parameters.Append .CreateParameter("guild", adVarChar, adParamInput, NAME_LENGTH, Trim$(Player(Index).Char(TempPlayer(Index).CharNum).Guild))
        .Parameters.Append .CreateParameter("guildaccess", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).GuildAccess)
        .Parameters.Append .CreateParameter("exp", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Exp)
        .Parameters.Append .CreateParameter("access", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Access)
        .Parameters.Append .CreateParameter("pk", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).PK)
        .Parameters.Append .CreateParameter("map", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Map)
        .Parameters.Append .CreateParameter("x", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).X)
        .Parameters.Append .CreateParameter("y", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Y)
        .Parameters.Append .CreateParameter("dir", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Dir)
        .Parameters.Append .CreateParameter("hp", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Vital(1))
        .Parameters.Append .CreateParameter("mp", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Vital(2))
        .Parameters.Append .CreateParameter("sp", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Vital(3))
        .Parameters.Append .CreateParameter("str", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Stat(1))
        .Parameters.Append .CreateParameter("def", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Stat(2))
        .Parameters.Append .CreateParameter("spe", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Stat(3))
        .Parameters.Append .CreateParameter("magi", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Stat(4))
        .Parameters.Append .CreateParameter("points", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).POINTS)
        .Parameters.Append .CreateParameter("weapon", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Equipment(1))
        .Parameters.Append .CreateParameter("armor", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Equipment(2))
        .Parameters.Append .CreateParameter("helmet", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Equipment(3))
        .Parameters.Append .CreateParameter("shield", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Equipment(4))
        .Parameters.Append .CreateParameter("inventory", adVarChar, adParamInput, Len(INVString), INVString)
        .Parameters.Append .CreateParameter("spells", adVarChar, adParamInput, Len(SPELLString), SPELLString)
        
        .Execute , , adExecuteNoRecords
    End With
    
    Set objCommand = Nothing
End Sub

Sub SaveNewAccount(ByVal Index As Long)
Dim rs As ADODB.Recordset, objCommand As ADODB.Command

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "INSERT INTO `accounts` (" & _
                        "`Login`, " & _
                        "`Password`, " & _
                        "`IPAddress`)" & _
                        "VALUES (?, ?, ?)"
        .Prepared = True
        
        .Parameters.Append .CreateParameter("login", adVarChar, adParamInput, ACCOUNT_LENGTH, Trim$(Player(Index).Login))
        .Parameters.Append .CreateParameter("password", adVarChar, adParamInput, PASS_LENGTH, Trim$(Player(Index).Password))
        .Parameters.Append .CreateParameter("ipaddress", adVarChar, adParamInput, NAME_LENGTH, Trim$(GetPlayerIP(Index)))
        
        .Execute , , adExecuteNoRecords
    End With
    
    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "SELECT * FROM accounts WHERE `Login`= ? LIMIT 1;"
        .Prepared = True
        
        .Parameters.Append .CreateParameter("login", adVarChar, adParamInput, ACCOUNT_LENGTH, Trim$(Player(Index).Login))
        
        Set rs = .Execute
    End With
    
    'Set the SQLID
    Player(Index).SQLID = CLng(rs("id"))
    
    Set objCommand = Nothing
End Sub

Sub SavePlayer(ByVal Index As Long)
Dim rs As ADODB.Recordset, objCommand As ADODB.Command
Dim I As Long, X As Long, Y As Long, n As Long
Dim SPELLString As String, INVString As String
    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "UPDATE `accounts` SET " & _
                        "`Login` = ?, " & _
                        "`Password` = ?, " & _
                        "`IPAddress` = ? " & _
                        "WHERE `id`= ?;"
        .Prepared = True
        
        .Parameters.Append .CreateParameter("login", adVarChar, adParamInput, ACCOUNT_LENGTH, Trim$(Player(Index).Login))
        .Parameters.Append .CreateParameter("password", adVarChar, adParamInput, PASS_LENGTH, Trim$(Player(Index).Password))
        .Parameters.Append .CreateParameter("ipaddress", adVarChar, adParamInput, NAME_LENGTH, Trim$(GetPlayerIP(Index)))
        .Parameters.Append .CreateParameter("sqlid", adInteger, adParamInput, , Player(Index).SQLID)
        
        .Execute , , adExecuteNoRecords
    End With
    
    'Do Characters
    INVString = ""
    SPELLString = ""
    
    With Player(Index).Char(TempPlayer(Index).CharNum)
        'Inventory
        For X = 1 To MAX_INV
            INVString = INVString & .Inv(X).Num & "-"
            INVString = INVString & .Inv(X).value & "|"
        Next X
    
        'Spells
        For X = 1 To MAX_PLAYER_SPELLS
            If X <> MAX_PLAYER_SPELLS Then
                SPELLString = SPELLString & .Spell(X) & "-"
            Else
                SPELLString = SPELLString & .Spell(X)
            End If
        Next X
    End With
    
    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "UPDATE `characters` SET " & _
                        "`Name` = ?, `Sex` = ?, `Class` = ?, `Sprite` = ?, `Level` = ?, " & _
                        "`Guild` = ?, `GuildAccess` = ?, " & _
                        "`Exp` = ?, `Access` = ?, `PK` = ?, " & _
                        "`Map` = ?, `X` = ?, `Y` = ?, `Dir` = ?, " & _
                        "`HP` = ?, `MP` = ?, `SP` = ?, " & _
                        "`Str` = ?, `Def` = ?, `Spe` = ?, `Magi` = ?, `POINTS` = ?, " & _
                        "`WeaponSlot` = ?, `ArmorSlot` = ?, `HelmetSlot` = ?, `ShieldSlot` = ?, " & _
                        "`Inventory` = ?, `Spells` = ? " & _
                        "WHERE `Name`= ?;"
        .Prepared = True

        .Parameters.Append .CreateParameter("name", adVarChar, adParamInput, NAME_LENGTH, Trim$(Player(Index).Char(TempPlayer(Index).CharNum).Name))
        .Parameters.Append .CreateParameter("sex", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Sex)
        .Parameters.Append .CreateParameter("class", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Class)
        .Parameters.Append .CreateParameter("sprite", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Sprite)
        .Parameters.Append .CreateParameter("level", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Level)
        .Parameters.Append .CreateParameter("guild", adVarChar, adParamInput, NAME_LENGTH, Trim$(Player(Index).Char(TempPlayer(Index).CharNum).Guild))
        .Parameters.Append .CreateParameter("guildaccess", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).GuildAccess)
        .Parameters.Append .CreateParameter("exp", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Exp)
        .Parameters.Append .CreateParameter("access", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Access)
        .Parameters.Append .CreateParameter("pk", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).PK)
        .Parameters.Append .CreateParameter("map", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Map)
        .Parameters.Append .CreateParameter("x", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).X)
        .Parameters.Append .CreateParameter("y", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Y)
        .Parameters.Append .CreateParameter("dir", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Dir)
        .Parameters.Append .CreateParameter("hp", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Vital(1))
        .Parameters.Append .CreateParameter("mp", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Vital(2))
        .Parameters.Append .CreateParameter("sp", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Vital(3))
        .Parameters.Append .CreateParameter("str", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Stat(1))
        .Parameters.Append .CreateParameter("def", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Stat(2))
        .Parameters.Append .CreateParameter("spe", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Stat(3))
        .Parameters.Append .CreateParameter("magi", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Stat(4))
        .Parameters.Append .CreateParameter("points", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).POINTS)
        .Parameters.Append .CreateParameter("weapon", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Equipment(1))
        .Parameters.Append .CreateParameter("armor", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Equipment(2))
        .Parameters.Append .CreateParameter("helmet", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Equipment(3))
        .Parameters.Append .CreateParameter("shield", adInteger, adParamInput, , Player(Index).Char(TempPlayer(Index).CharNum).Equipment(4))
        .Parameters.Append .CreateParameter("inventory", adVarChar, adParamInput, Len(INVString), INVString)
        .Parameters.Append .CreateParameter("spells", adVarChar, adParamInput, Len(SPELLString), SPELLString)
        .Parameters.Append .CreateParameter("name", adVarChar, adParamInput, NAME_LENGTH, Trim$(Player(Index).Char(TempPlayer(Index).CharNum).Name))
        
        .Execute , , adExecuteNoRecords
    End With
    Set objCommand = Nothing
End Sub

Sub DeleteChar(ByVal Index As Long, ByVal CharNum As Long)
Dim objCommand As ADODB.Command

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "DELETE FROM characters WHERE `Name`= ?;"
        .Prepared = True
        
        .Parameters.Append .CreateParameter("name", adVarChar, adParamInput, NAME_LENGTH, Trim$(Player(Index).Char(CharNum).Name))
        
        .Execute , , adExecuteNoRecords
    End With
    
    Set objCommand = Nothing
End Sub

Sub LoadPlayer(ByVal Index As Long, ByVal Name As String)
Dim I As Long, n As Long
Dim rs As ADODB.Recordset, objCommand As ADODB.Command
Dim Inv1() As String, Inv2() As String
Dim Spells() As String

    'ClearPlayer
    Call ClearPlayer(Index)
    
    Set objCommand = New ADODB.Command
    
'' ACCOUNT
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "SELECT * FROM accounts WHERE `Login`= ? LIMIT 1;"
        .Prepared = True
        
        .Parameters.Append .CreateParameter("login", adVarChar, adParamInput, ACCOUNT_LENGTH, Trim$(Name))
        
        Set rs = .Execute
    End With
    
    'Load Account
    With Player(Index)
        .SQLID = CLng(rs("id"))
        .Login = Trim$(CStr(rs("Login")))
        .Password = Trim$(CStr(rs("Password")))
    End With
    
    Set objCommand = Nothing
        
'' CHARACTERS

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "SELECT * FROM Characters WHERE `account`= ? LIMIT 6;"
        .Prepared = True
        
        .Parameters.Append .CreateParameter("account", adInteger, adParamInput, ACCOUNT_LENGTH, Player(Index).SQLID)
        
        Set rs = .Execute
    End With
    
    'Setup database stuff
    'rs.MoveFirst
    For I = 1 To MAX_CHARS
        If Not rs.EOF Then
            With Player(Index).Char(I)
                ' General
                .Name = Trim$(CStr(rs("Name")))
                .Sex = CLng(rs("Sex"))
                .Class = CLng(rs("Class"))
                .Sprite = CLng(rs("Sprite"))
                .Level = CLng(rs("Level"))
                .Guild = Trim$(CStr(rs("Guild")))
                .GuildAccess = CLng(rs("GuildAccess"))
                .Exp = CLng(rs("Exp"))
                .Access = CLng(rs("Access"))
                .PK = CLng(rs("PK"))
                
                ' Vitals
                .Vital(1) = CLng(rs("HP"))
                .Vital(2) = CLng(rs("MP"))
                .Vital(3) = CLng(rs("SP"))
                
                ' Stats
                .Stat(1) = CLng(rs("STR"))
                .Stat(2) = CLng(rs("DEF"))
                .Stat(3) = CLng(rs("SPE"))
                .Stat(4) = CLng(rs("MAGI"))
                .POINTS = CLng(rs("POINTS"))
                
                ' Worn equipment
                .Equipment(1) = CLng(rs("WeaponSlot"))
                .Equipment(2) = CLng(rs("ArmorSlot"))
                .Equipment(3) = CLng(rs("HelmetSlot"))
                .Equipment(4) = CLng(rs("ShieldSlot"))
                
                ' Position
                .Map = CLng(rs("Map"))
                .X = CLng(rs("X"))
                .Y = CLng(rs("Y"))
                .Dir = CLng(rs("Dir"))
                
                ' Check to make sure that they aren't on map 0, if so reset'm
                If .Map = 0 Then
                    .Map = START_MAP
                    .X = START_X
                    .Y = START_Y
                End If
                
                ' Inventory
                Inv1 = Split(rs("Inventory"), "|")
                        
                For n = 1 To MAX_INV
                    Inv2 = Split(Inv1(n - 1), "-")
                    .Inv(n).Num = CLng(Inv2(0))
                    .Inv(n).value = CLng(Inv2(1))
                Next n
                
                ' Spells
                Spells = Split(rs("Spells"), "-")
                For n = 1 To MAX_PLAYER_SPELLS
                    .Spell(n) = Spells(n - 1)
                Next n
            End With
            Set objCommand = Nothing
        Else
            With Player(Index).Char(I)
                ' General
                .Name = ""
                .Sex = 0
                .Class = 0
                .Sprite = 0
                .Level = 0
                .Guild = 0
                .GuildAccess = 0
                .Exp = 0
                .Access = 0
                .PK = 0
                
                ' Vitals
                .Vital(1) = 0
                .Vital(2) = 0
                .Vital(3) = 0
                
                ' Stats
                .Stat(1) = 0
                .Stat(2) = 0
                .Stat(3) = 0
                .Stat(4) = 0
                .POINTS = 0
                
                ' Worn equipment
                .Equipment(1) = 0
                .Equipment(2) = 0
                .Equipment(3) = 0
                .Equipment(4) = 0
                
                ' Position
                .Map = 0
                .X = 0
                .Y = 0
                .Dir = 0
                
                ' Check to make sure that they aren't on map 0, if so reset'm
                If .Map = 0 Then
                    .Map = START_MAP
                    .X = START_X
                    .Y = START_Y
                End If
                
                ' Inventory
                For n = 1 To MAX_INV
                    .Inv(n).Num = 0
                    .Inv(n).value = 0
                Next n
                
                ' Spells
                For n = 1 To MAX_PLAYER_SPELLS
                    .Spell(n) = 0
                Next n
            End With
        End If
        If Not rs.EOF Then
            rs.MoveNext
        End If
    Next I
    
    'Delete all references
    rs.Close
    Set rs = Nothing
End Sub

Public Sub ClearPlayer(ByVal Index As Long)
    Dim I As Long
    
    ' Clear the tempPlayer also
    Call ZeroMemory(ByVal VarPtr(TempPlayer(Index)), LenB(TempPlayer(Index)))
    Set TempPlayer(Index).Buffer = New clsBuffer
    
    ' Clear the player UDT
    Call ZeroMemory(ByVal VarPtr(Player(Index)), LenB(Player(Index)))
    
    Player(Index).Login = vbNullString
    Player(Index).Password = vbNullString
    
    For I = 0 To MAX_CHARS
        Call ClearChar(Index, I)
    Next
    
    frmServer.lvwInfo.ListItems(Index).SubItems(1) = vbNullString
    frmServer.lvwInfo.ListItems(Index).SubItems(2) = vbNullString
    frmServer.lvwInfo.ListItems(Index).SubItems(3) = vbNullString
End Sub

Public Sub ClearChar(ByVal Index As Long, ByVal CharNum As Long)
    Call ZeroMemory(ByVal VarPtr(Player(Index).Char(CharNum)), LenB(Player(Index).Char(CharNum)))
    Player(Index).Char(CharNum).Name = vbNullString
    Player(Index).Char(CharNum).Class = 1
End Sub

' *************
' ** Classes **
' *************

Public Sub CreateClassesINI()
    Dim FileName As String
    Dim File As String
    
    FileName = App.Path & "\data\classes.ini"
    
    Max_Classes = 2
    
    If Not FileExist(FileName, True) Then
        File = FreeFile
        
        Open FileName For Output As File
        Print #File, "[INIT]"
        Print #File, "MaxClasses=" & Max_Classes
        Close File
    End If
    
End Sub

Public Sub LoadClasses()
    Dim FileName As String
    Dim I As Long
    
    If CheckClasses Then
        ReDim Class(1 To Max_Classes)
        Call SaveClasses
    Else
        FileName = App.Path & "\data\classes.ini"
        Max_Classes = Val(GetVar(FileName, "INIT", "MaxClasses"))
        ReDim Class(1 To Max_Classes)
        
    End If
    
    For I = 1 To Max_Classes
        Class(I).Name = GetVar(FileName, "CLASS" & I, "Name")
        Class(I).Sprite = Val(GetVar(FileName, "CLASS" & I, "Sprite"))
        Class(I).Stat(Stats.Strength) = Val(GetVar(FileName, "CLASS" & I, "STR"))
        Class(I).Stat(Stats.Defense) = Val(GetVar(FileName, "CLASS" & I, "DEF"))
        Class(I).Stat(Stats.Speed) = Val(GetVar(FileName, "CLASS" & I, "Speed"))
        Class(I).Stat(Stats.Magic) = Val(GetVar(FileName, "CLASS" & I, "MAGI"))
    Next
End Sub

Public Sub SaveClasses()
    Dim FileName As String
    Dim I As Long
    
    FileName = App.Path & "\data\classes.ini"
    
    For I = 1 To Max_Classes
        Call PutVar(FileName, "CLASS" & I, "Name", Trim$(Class(I).Name))
        Call PutVar(FileName, "CLASS" & I, "Sprite", CStr(Class(I).Sprite))
        Call PutVar(FileName, "CLASS" & I, "STR", CStr(Class(I).Stat(Stats.Strength)))
        Call PutVar(FileName, "CLASS" & I, "DEF", CStr(Class(I).Stat(Stats.Defense)))
        Call PutVar(FileName, "CLASS" & I, "Speed", CStr(Class(I).Stat(Stats.Speed)))
        Call PutVar(FileName, "CLASS" & I, "MAGI", CStr(Class(I).Stat(Stats.Magic)))
    Next
End Sub

Public Function CheckClasses() As Boolean
    Dim FileName As String
    
    FileName = App.Path & "\data\classes.ini"
    
    If Not FileExist(FileName, True) Then
        Call CreateClassesINI
        CheckClasses = True
    End If
    
End Function

Public Sub ClearClasses()
    Dim I As Long
    
    For I = 1 To Max_Classes
        Call ZeroMemory(ByVal VarPtr(Class(I)), LenB(Class(I)))
        Class(I).Name = vbNullString
    Next
End Sub

' ***********
' ** Items **
' ***********

Public Sub SaveItems()
    Dim I As Long
    
    For I = 1 To MAX_ITEMS
        Call SaveItem(I)
    Next
End Sub

Public Sub SaveItem(ByVal ItemNum As Long)
Dim rs As ADODB.Recordset, objCommand As ADODB.Command

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "UPDATE `items` SET " & _
                        "`Name` = ?, `Pic` = ?, `Type` = ?, `Data1` = ?, `Data2` = ?, `Data3` = ? " & _
                        "WHERE `id`= ?;"
        .Prepared = True
        
        .Parameters.Append .CreateParameter("name", adVarChar, adParamInput, NAME_LENGTH, Trim$(Item(ItemNum).Name))
        .Parameters.Append .CreateParameter("pic", adInteger, adParamInput, , Item(ItemNum).Pic)
        .Parameters.Append .CreateParameter("type", adInteger, adParamInput, , Item(ItemNum).Type)
        .Parameters.Append .CreateParameter("data1", adInteger, adParamInput, , Item(ItemNum).Data1)
        .Parameters.Append .CreateParameter("data2", adInteger, adParamInput, , Item(ItemNum).Data2)
        .Parameters.Append .CreateParameter("data3", adInteger, adParamInput, , Item(ItemNum).Data3)
        .Parameters.Append .CreateParameter("sqlid", adInteger, adParamInput, , ItemNum)
        
        .Execute , , adExecuteNoRecords
    End With
    Set objCommand = Nothing
End Sub

Public Sub LoadItems()
Dim rs As ADODB.Recordset, objCommand As ADODB.Command
Dim I As Long

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "SELECT * FROM items;"
        .Prepared = True
        
        Set rs = .Execute
    End With
    
    rs.MoveFirst
    For I = 1 To MAX_ITEMS
        Item(I).Name = rs!Name
        Item(I).Pic = rs!Pic
        Item(I).Type = rs!Type
        Item(I).Data1 = rs!Data1
        Item(I).Data2 = rs!Data2
        Item(I).Data3 = rs!Data3
        rs.MoveNext
    Next I
    
    Set rs = Nothing
    Set objCommand = Nothing

End Sub

Public Sub ClearItem(ByVal Index As Long)
    Call ZeroMemory(ByVal VarPtr(Item(Index)), LenB(Item(Index)))
    Item(Index).Name = vbNullString
End Sub

Public Sub ClearItems()
    Dim I As Long
    
    For I = 1 To MAX_ITEMS
        Call ClearItem(I)
    Next
End Sub

' ***********
' ** Shops **
' ***********

Public Sub SaveShops()
    Dim I As Long
    
    For I = 1 To MAX_SHOPS
        Call SaveShop(I)
    Next
End Sub

Public Sub SaveShop(ByVal ShopNum As Long)
Dim rs As ADODB.Recordset, objCommand As ADODB.Command

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "UPDATE `shops` SET " & _
                        "`Name` = ?, `FixesItems` = ?, `JoinSay` = ?, `LeaveSay` = ?, " & _
                        "`GiveItem1` = ?, `GiveValue1` = ?, `GetItem1` = ?, `GetValue1` = ?, " & _
                        "`GiveItem2` = ?, `GiveValue2` = ?, `GetItem2` = ?, `GetValue2` = ?, " & _
                        "`GiveItem3` = ?, `GiveValue3` = ?, `GetItem3` = ?, `GetValue3` = ?, " & _
                        "`GiveItem4` = ?, `GiveValue4` = ?, `GetItem4` = ?, `GetValue4` = ?, " & _
                        "`GiveItem5` = ?, `GiveValue5` = ?, `GetItem5` = ?, `GetValue5` = ?, " & _
                        "`GiveItem6` = ?, `GiveValue6` = ?, `GetItem6` = ?, `GetValue6` = ?, " & _
                        "`GiveItem7` = ?, `GiveValue7` = ?, `GetItem7` = ?, `GetValue7` = ?, " & _
                        "`GiveItem8` = ?, `GiveValue8` = ?, `GetItem8` = ?, `GetValue8` = ? " & _
                        "WHERE `id`= ?;"
        .Prepared = True
        
        .Parameters.Append .CreateParameter("name", adVarChar, adParamInput, NAME_LENGTH, Trim$(Shop(ShopNum).Name))
        .Parameters.Append .CreateParameter("fixesitems", adInteger, adParamInput, , Shop(ShopNum).FixesItems)
        .Parameters.Append .CreateParameter("joinsay", adVarChar, adParamInput, 255, Trim$(Shop(ShopNum).JoinSay))
        .Parameters.Append .CreateParameter("leavesay", adVarChar, adParamInput, 255, Trim$(Shop(ShopNum).LeaveSay))
        .Parameters.Append .CreateParameter("GiveItem1", adInteger, adParamInput, , Shop(ShopNum).TradeItem(1).GiveItem)
        .Parameters.Append .CreateParameter("GiveValue1", adInteger, adParamInput, , Shop(ShopNum).TradeItem(1).GiveValue)
        .Parameters.Append .CreateParameter("GetItem1", adInteger, adParamInput, , Shop(ShopNum).TradeItem(1).GetItem)
        .Parameters.Append .CreateParameter("GetValue1", adInteger, adParamInput, , Shop(ShopNum).TradeItem(1).GetValue)
        .Parameters.Append .CreateParameter("GiveItem2", adInteger, adParamInput, , Shop(ShopNum).TradeItem(2).GiveItem)
        .Parameters.Append .CreateParameter("GiveValue2", adInteger, adParamInput, , Shop(ShopNum).TradeItem(2).GiveValue)
        .Parameters.Append .CreateParameter("GetItem2", adInteger, adParamInput, , Shop(ShopNum).TradeItem(2).GetItem)
        .Parameters.Append .CreateParameter("GetValue2", adInteger, adParamInput, , Shop(ShopNum).TradeItem(2).GetValue)
        .Parameters.Append .CreateParameter("GiveItem3", adInteger, adParamInput, , Shop(ShopNum).TradeItem(3).GiveItem)
        .Parameters.Append .CreateParameter("GiveValue3", adInteger, adParamInput, , Shop(ShopNum).TradeItem(3).GiveValue)
        .Parameters.Append .CreateParameter("GetItem3", adInteger, adParamInput, , Shop(ShopNum).TradeItem(3).GetItem)
        .Parameters.Append .CreateParameter("GetValue3", adInteger, adParamInput, , Shop(ShopNum).TradeItem(3).GetValue)
        .Parameters.Append .CreateParameter("GiveItem4", adInteger, adParamInput, , Shop(ShopNum).TradeItem(4).GiveItem)
        .Parameters.Append .CreateParameter("GiveValue4", adInteger, adParamInput, , Shop(ShopNum).TradeItem(4).GiveValue)
        .Parameters.Append .CreateParameter("GetItem4", adInteger, adParamInput, , Shop(ShopNum).TradeItem(4).GetItem)
        .Parameters.Append .CreateParameter("GetValue4", adInteger, adParamInput, , Shop(ShopNum).TradeItem(4).GetValue)
        .Parameters.Append .CreateParameter("GiveItem5", adInteger, adParamInput, , Shop(ShopNum).TradeItem(5).GiveItem)
        .Parameters.Append .CreateParameter("GiveValue5", adInteger, adParamInput, , Shop(ShopNum).TradeItem(5).GiveValue)
        .Parameters.Append .CreateParameter("GetItem5", adInteger, adParamInput, , Shop(ShopNum).TradeItem(5).GetItem)
        .Parameters.Append .CreateParameter("GetValue5", adInteger, adParamInput, , Shop(ShopNum).TradeItem(5).GetValue)
        .Parameters.Append .CreateParameter("GiveItem6", adInteger, adParamInput, , Shop(ShopNum).TradeItem(6).GiveItem)
        .Parameters.Append .CreateParameter("GiveValue6", adInteger, adParamInput, , Shop(ShopNum).TradeItem(6).GiveValue)
        .Parameters.Append .CreateParameter("GetItem6", adInteger, adParamInput, , Shop(ShopNum).TradeItem(6).GetItem)
        .Parameters.Append .CreateParameter("GetValue6", adInteger, adParamInput, , Shop(ShopNum).TradeItem(6).GetValue)
        .Parameters.Append .CreateParameter("GiveItem7", adInteger, adParamInput, , Shop(ShopNum).TradeItem(7).GiveItem)
        .Parameters.Append .CreateParameter("GiveValue7", adInteger, adParamInput, , Shop(ShopNum).TradeItem(7).GiveValue)
        .Parameters.Append .CreateParameter("GetItem7", adInteger, adParamInput, , Shop(ShopNum).TradeItem(7).GetItem)
        .Parameters.Append .CreateParameter("GetValue7", adInteger, adParamInput, , Shop(ShopNum).TradeItem(7).GetValue)
        .Parameters.Append .CreateParameter("GiveItem8", adInteger, adParamInput, , Shop(ShopNum).TradeItem(8).GiveItem)
        .Parameters.Append .CreateParameter("GiveValue8", adInteger, adParamInput, , Shop(ShopNum).TradeItem(8).GiveValue)
        .Parameters.Append .CreateParameter("GetItem8", adInteger, adParamInput, , Shop(ShopNum).TradeItem(8).GetItem)
        .Parameters.Append .CreateParameter("GetValue8", adInteger, adParamInput, , Shop(ShopNum).TradeItem(8).GetValue)
        .Parameters.Append .CreateParameter("sqlid", adInteger, adParamInput, , ShopNum)
        
        .Execute , , adExecuteNoRecords
    End With
    Set objCommand = Nothing
End Sub

Public Sub LoadShops()
Dim rs As ADODB.Recordset, objCommand As ADODB.Command
Dim I As Long

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "SELECT * FROM shops;"
        .Prepared = True
        
        Set rs = .Execute
    End With
    
    rs.MoveFirst
    For I = 1 To MAX_SHOPS
        Shop(I).Name = rs!Name
        Shop(I).FixesItems = rs!FixesItems
        Shop(I).JoinSay = rs!JoinSay
        Shop(I).LeaveSay = rs!LeaveSay
        Shop(I).TradeItem(1).GiveItem = rs!GiveItem1
        Shop(I).TradeItem(1).GiveValue = rs!GiveValue1
        Shop(I).TradeItem(1).GetItem = rs!GetItem1
        Shop(I).TradeItem(1).GetValue = rs!GetValue1
        Shop(I).TradeItem(2).GiveItem = rs!GiveItem2
        Shop(I).TradeItem(2).GiveValue = rs!GiveValue2
        Shop(I).TradeItem(2).GetItem = rs!GetItem2
        Shop(I).TradeItem(2).GetValue = rs!GetValue2
        Shop(I).TradeItem(3).GiveItem = rs!GiveItem3
        Shop(I).TradeItem(3).GiveValue = rs!GiveValue3
        Shop(I).TradeItem(3).GetItem = rs!GetItem3
        Shop(I).TradeItem(3).GetValue = rs!GetValue3
        Shop(I).TradeItem(4).GiveItem = rs!GiveItem4
        Shop(I).TradeItem(4).GiveValue = rs!GiveValue4
        Shop(I).TradeItem(4).GetItem = rs!GetItem4
        Shop(I).TradeItem(4).GetValue = rs!GetValue4
        Shop(I).TradeItem(5).GiveItem = rs!GiveItem5
        Shop(I).TradeItem(5).GiveValue = rs!GiveValue5
        Shop(I).TradeItem(5).GetItem = rs!GetItem5
        Shop(I).TradeItem(5).GetValue = rs!GetValue5
        Shop(I).TradeItem(6).GiveItem = rs!GiveItem6
        Shop(I).TradeItem(6).GiveValue = rs!GiveValue6
        Shop(I).TradeItem(6).GetItem = rs!GetItem6
        Shop(I).TradeItem(6).GetValue = rs!GetValue6
        Shop(I).TradeItem(7).GiveItem = rs!GiveItem7
        Shop(I).TradeItem(7).GiveValue = rs!GiveValue7
        Shop(I).TradeItem(7).GetItem = rs!GetItem7
        Shop(I).TradeItem(7).GetValue = rs!GetValue7
        Shop(I).TradeItem(8).GiveItem = rs!GiveItem8
        Shop(I).TradeItem(8).GiveValue = rs!GiveValue8
        Shop(I).TradeItem(8).GetItem = rs!GetItem8
        Shop(I).TradeItem(8).GetValue = rs!GetValue8
        rs.MoveNext
    Next I
    
    Set rs = Nothing
    Set objCommand = Nothing

End Sub

Public Sub ClearShop(ByVal Index As Long)
    Call ZeroMemory(ByVal VarPtr(Shop(Index)), LenB(Shop(Index)))
    Shop(Index).Name = vbNullString
    Shop(Index).JoinSay = vbNullString
    Shop(Index).LeaveSay = vbNullString
End Sub

Public Sub ClearShops()
    Dim I As Long
    
    For I = 1 To MAX_SHOPS
        Call ClearShop(I)
    Next
End Sub

' ************
' ** Spells **
' ************

Public Sub SaveSpell(ByVal SpellNum As Long)
Dim rs As ADODB.Recordset, objCommand As ADODB.Command

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "UPDATE `spells` SET " & _
                        "`Name` = ?, `Pic` = ?, " & _
                        "`Type` = ?, `MPReq` = ?, `LevelReq` = ?, `ClassReq` = ?, " & _
                        "`Data1` = ?, `Data2` = ?, `Data3` = ? " & _
                        "WHERE `id`= ?;"
        .Prepared = True
    
        .Parameters.Append .CreateParameter("name", adVarChar, adParamInput, NAME_LENGTH, Trim$(Spell(SpellNum).Name))
        .Parameters.Append .CreateParameter("pic", adInteger, adParamInput, , Spell(SpellNum).Pic)
        .Parameters.Append .CreateParameter("type", adInteger, adParamInput, , Spell(SpellNum).Type)
        .Parameters.Append .CreateParameter("mpreq", adInteger, adParamInput, , Spell(SpellNum).MPReq)
        .Parameters.Append .CreateParameter("levelreq", adInteger, adParamInput, , Spell(SpellNum).LevelReq)
        .Parameters.Append .CreateParameter("classreq", adInteger, adParamInput, , Spell(SpellNum).ClassReq)
        .Parameters.Append .CreateParameter("data1", adInteger, adParamInput, , Spell(SpellNum).Data1)
        .Parameters.Append .CreateParameter("data2", adInteger, adParamInput, , Spell(SpellNum).Data2)
        .Parameters.Append .CreateParameter("data3", adInteger, adParamInput, , Spell(SpellNum).Data3)
        .Parameters.Append .CreateParameter("sqlid", adInteger, adParamInput, , SpellNum)
        
        .Execute , , adExecuteNoRecords
    End With
    Set objCommand = Nothing
End Sub

Public Sub SaveSpells()
    Dim I As Long
    
    Call SetStatus("Saving spells... ")
    For I = 1 To MAX_SPELLS
        Call SaveSpell(I)
    Next
End Sub

Public Sub LoadSpells()
Dim rs As ADODB.Recordset, objCommand As ADODB.Command
Dim I As Long

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "SELECT * FROM spells;"
        .Prepared = True
        
        Set rs = .Execute
    End With
    
    rs.MoveFirst
    For I = 1 To MAX_SPELLS
        Spell(I).Name = rs!Name
        Spell(I).Pic = rs!Pic
        Spell(I).Type = rs!Type
        Spell(I).MPReq = rs!MPReq
        Spell(I).LevelReq = rs!LevelReq
        Spell(I).ClassReq = rs!ClassReq
        Spell(I).Data1 = rs!Data1
        Spell(I).Data2 = rs!Data2
        Spell(I).Data3 = rs!Data3
        rs.MoveNext
    Next I
    
    Set rs = Nothing
    Set objCommand = Nothing

End Sub

Public Sub ClearSpell(ByVal Index As Long)
    Call ZeroMemory(ByVal VarPtr(Spell(Index)), LenB(Spell(Index)))
    Spell(Index).Name = vbNullString
    Spell(Index).LevelReq = 1 'Needs to be 1 for the spell editor
End Sub

Public Sub ClearSpells()
    Dim I As Long
    
    For I = 1 To MAX_SPELLS
        Call ClearSpell(I)
    Next
End Sub

' **********
' ** Npcs **
' **********

Public Sub SaveNpcs()
    Dim I As Long
    
    For I = 1 To MAX_NPCS
        Call SaveNpc(I)
    Next
End Sub

Public Sub SaveNpc(ByVal NpcNum As Long)
Dim rs As ADODB.Recordset, objCommand As ADODB.Command

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "UPDATE `npcs` SET " & _
                        "`Name` = ?, `AttackSay` = ?, " & _
                        "`Sprite` = ?, `SpawnSecs` = ?, `Behavior` = ?, `Range` = ?, " & _
                        "`DropChance` = ?, `DropItem` = ?, `DropItemValue` = ?, " & _
                        "`STR` = ?, `DEF` = ?, `SPE` = ?, `MAGI` = ? " & _
                        "WHERE `id`= ?;"
        .Prepared = True
    
        .Parameters.Append .CreateParameter("name", adVarChar, adParamInput, NAME_LENGTH, Trim$(Npc(NpcNum).Name))
        .Parameters.Append .CreateParameter("attacksay", adVarChar, adParamInput, 100, Trim$(Npc(NpcNum).AttackSay))
        .Parameters.Append .CreateParameter("sprite", adInteger, adParamInput, , Npc(NpcNum).Sprite)
        .Parameters.Append .CreateParameter("spawnsecs", adInteger, adParamInput, , Npc(NpcNum).SpawnSecs)
        .Parameters.Append .CreateParameter("behavior", adInteger, adParamInput, , Npc(NpcNum).Behavior)
        .Parameters.Append .CreateParameter("range", adInteger, adParamInput, , Npc(NpcNum).Range)
        .Parameters.Append .CreateParameter("dropchance", adInteger, adParamInput, , Npc(NpcNum).DropChance)
        .Parameters.Append .CreateParameter("dropitem", adInteger, adParamInput, , Npc(NpcNum).DropItem)
        .Parameters.Append .CreateParameter("dropitemvalue", adInteger, adParamInput, , Npc(NpcNum).DropItemValue)
        .Parameters.Append .CreateParameter("str", adInteger, adParamInput, , Npc(NpcNum).Stat(1))
        .Parameters.Append .CreateParameter("def", adInteger, adParamInput, , Npc(NpcNum).Stat(2))
        .Parameters.Append .CreateParameter("spe", adInteger, adParamInput, , Npc(NpcNum).Stat(3))
        .Parameters.Append .CreateParameter("magi", adInteger, adParamInput, , Npc(NpcNum).Stat(4))
        .Parameters.Append .CreateParameter("sqlid", adInteger, adParamInput, , NpcNum)
        
        .Execute , , adExecuteNoRecords
    End With
    Set objCommand = Nothing
End Sub

Public Sub LoadNpcs()
Dim rs As ADODB.Recordset, objCommand As ADODB.Command
Dim I As Long

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "SELECT * FROM npcs;"
        .Prepared = True
        
        Set rs = .Execute
    End With
    
    rs.MoveFirst
    For I = 1 To MAX_NPCS
        Npc(I).Name = rs!Name
        Npc(I).AttackSay = rs!AttackSay
        
        Npc(I).Sprite = rs!Sprite
        Npc(I).SpawnSecs = rs!SpawnSecs
        Npc(I).Behavior = rs!Behavior
        Npc(I).Range = rs!Range
        Npc(I).DropChance = rs!DropChance
        Npc(I).DropItem = rs!DropItem
        Npc(I).DropItemValue = rs!DropItemValue
        Npc(I).Stat(1) = rs!Str
        Npc(I).Stat(2) = rs!DEF
        Npc(I).Stat(3) = rs!SPE
        Npc(I).Stat(4) = rs!MAGI
        rs.MoveNext
    Next I
    
    Set rs = Nothing
    Set objCommand = Nothing

End Sub

Public Sub ClearNpc(ByVal Index As Long)
    Call ZeroMemory(ByVal VarPtr(Npc(Index)), LenB(Npc(Index)))
    Npc(Index).Name = vbNullString
    Npc(Index).AttackSay = vbNullString
End Sub

Public Sub ClearNpcs()
    Dim I As Long
    
    For I = 1 To MAX_NPCS
        Call ClearNpc(I)
    Next
End Sub

' **********
' ** Maps **
' **********

Public Sub SaveMap(ByVal MapNum As Long)
Dim X As Long, Y As Long, I As Long, z As Long, w As Long
Dim LayersStr As String, AutotileStr As String, DataStr As String, NPCStr As String

Dim rs As ADODB.Recordset, objCommand As ADODB.Command

    Set objCommand = New ADODB.Command
    
    For X = 0 To MAX_MAPX
        For Y = 0 To MAX_MAPY
            For I = 0 To 8
                LayersStr = LayersStr & Map(MapNum).Tile(X, Y).Num(I) & "|"
            Next
            DataStr = DataStr & Map(MapNum).Tile(X, Y).Type & "-"
            DataStr = DataStr & Map(MapNum).Tile(X, Y).Data1 & "-"
            DataStr = DataStr & Map(MapNum).Tile(X, Y).Data2 & "-"
            DataStr = DataStr & Map(MapNum).Tile(X, Y).Data3 & "|"
        Next
    Next

    For X = 1 To MAX_MAP_NPCS
        NPCStr = NPCStr & Map(MapNum).Npc(X) & "|"
    Next
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "UPDATE `maps` SET " & _
                        "`Name` = ?, `Music` = ?, `TileSet` = ?, " & _
                        "`Revision` = ?, `Moral` = ?, `Up` = ?, `Down` = ?, `mLeft` = ?, `mRight` = ?, " & _
                        "`BootMap` = ?, `BootX` = ?, `BootY` = ?, `Shop` = ?, " & _
                        "`Tile` = ?, `TileData` = ?, `NPCs` = ? " & _
                        "WHERE `id`= ?;"
        .Prepared = True
        
        .Parameters.Append .CreateParameter("name", adVarChar, adParamInput, NAME_LENGTH, Trim$(Map(MapNum).Name))
        .Parameters.Append .CreateParameter("music", adInteger, adParamInput, , Map(MapNum).Music)
        .Parameters.Append .CreateParameter("tileset", adInteger, adParamInput, , Map(MapNum).TileSet)
        .Parameters.Append .CreateParameter("revision", adInteger, adParamInput, , Map(MapNum).Revision)
        .Parameters.Append .CreateParameter("moral", adInteger, adParamInput, , Map(MapNum).Moral)
        .Parameters.Append .CreateParameter("up", adInteger, adParamInput, , Map(MapNum).Up)
        .Parameters.Append .CreateParameter("down", adInteger, adParamInput, , Map(MapNum).Down)
        .Parameters.Append .CreateParameter("left", adInteger, adParamInput, , Map(MapNum).Left)
        .Parameters.Append .CreateParameter("right", adInteger, adParamInput, , Map(MapNum).Right)
        .Parameters.Append .CreateParameter("bootmap", adInteger, adParamInput, , Map(MapNum).BootMap)
        .Parameters.Append .CreateParameter("bootx", adInteger, adParamInput, , Map(MapNum).BootX)
        .Parameters.Append .CreateParameter("booty", adInteger, adParamInput, , Map(MapNum).BootY)
        .Parameters.Append .CreateParameter("shop", adInteger, adParamInput, , Map(MapNum).Shop)
        .Parameters.Append .CreateParameter("tile", adVarChar, adParamInput, Len(LayersStr), LayersStr)
        .Parameters.Append .CreateParameter("tiledata", adVarChar, adParamInput, Len(DataStr), DataStr)
        .Parameters.Append .CreateParameter("npcs", adVarChar, adParamInput, Len(NPCStr), NPCStr)
        .Parameters.Append .CreateParameter("sqlid", adInteger, adParamInput, , MapNum)
        
        .Execute , , adExecuteNoRecords
    End With
    Set objCommand = Nothing
End Sub

Public Sub SaveMaps()
    Dim I As Long
    
    For I = 1 To MAX_MAPS
        Call SaveMap(I)
    Next
End Sub

Public Sub LoadMaps()
Dim rs As ADODB.Recordset, objCommand As ADODB.Command
Dim I As Long, tl As Long, td As Long, n As Long, z As Long, X As Long, Y As Long
Dim LayersStr() As String, AutotileStr() As String, DataStr() As String, NPCStr() As String
Dim DataStr2() As String

    Set objCommand = New ADODB.Command
    
    With objCommand
        .ActiveConnection = "DRIVER={SQLite3 ODBC Driver};DATABASE=legacy.db"
        .CommandType = adCmdText
        .CommandText = "SELECT * FROM maps;"
        .Prepared = True
        
        Set rs = .Execute
    End With
    
    rs.MoveFirst
    For I = 1 To MAX_MAPS
        Map(I).Name = rs!Name
        Map(I).Music = rs!Music
        Map(I).TileSet = rs!TileSet
        Map(I).Revision = rs!Revision
        Map(I).Moral = rs!Moral
        Map(I).Up = rs!Up
        Map(I).Down = rs!Down
        Map(I).Left = rs!mLeft
        Map(I).Right = rs!mRight
        Map(I).BootMap = rs!BootMap
        Map(I).BootX = rs!BootX
        Map(I).BootY = rs!BootY
        
        Map(I).Shop = rs!Shop
        
        ' have to set the tile()
        'ReDim Map(i).Tile(0 To MAX_MAPX, 0 To MAX_MAPY)
    
        ' Tile Data
        LayersStr = Split(rs("Tile"), "|")
        DataStr = Split(rs("TileData"), "|")
        NPCStr = Split(rs("NPCs"), "|")
        
        tl = 0
        td = 0
                
        For X = 0 To MAX_MAPX
            For Y = 0 To MAX_MAPY
                For n = 0 To 8
                    Map(I).Tile(X, Y).Num(n) = LayersStr(tl)
                    tl = tl + 1
                Next
                DataStr2 = Split(DataStr(td), "-")
                Map(I).Tile(X, Y).Type = DataStr2(0)
                Map(I).Tile(X, Y).Data1 = DataStr2(1)
                Map(I).Tile(X, Y).Data2 = DataStr2(2)
                Map(I).Tile(X, Y).Data3 = DataStr2(3)
                td = td + 1
            Next
        Next
    
        For X = 1 To MAX_MAP_NPCS
            Map(I).Npc(X) = NPCStr(X - 1)
            'MapNpc(i).Num = Map(i).Npc(X)
        Next
    
        ClearTempTile
        DoEvents
        
        rs.MoveNext
    Next
    
    Set rs = Nothing
    Set objCommand = Nothing
End Sub

Public Sub ClearMapItem(ByVal Index As Long, ByVal MapNum As Long)
    Call ZeroMemory(ByVal VarPtr(MapItem(MapNum, Index)), LenB(MapItem(MapNum, Index)))
End Sub

Public Sub ClearMapItems()
    Dim X As Long
    Dim Y As Long
    
    For Y = 1 To MAX_MAPS
        For X = 1 To MAX_MAP_ITEMS
            Call ClearMapItem(X, Y)
        Next
    Next
End Sub

Public Sub ClearMapNpc(ByVal Index As Long, ByVal MapNum As Long)
    Call ZeroMemory(ByVal VarPtr(MapNpc(MapNum, Index)), LenB(MapNpc(MapNum, Index)))
End Sub

Public Sub ClearMapNpcs()
    Dim X As Long
    Dim Y As Long
    
    For Y = 1 To MAX_MAPS
        For X = 1 To MAX_MAP_NPCS
            Call ClearMapNpc(X, Y)
        Next
    Next
End Sub

Public Sub ClearMap(ByVal MapNum As Long)
    Call ZeroMemory(ByVal VarPtr(Map(MapNum)), LenB(Map(MapNum)))
    
    Map(MapNum).TileSet = 1
    
    Map(MapNum).Name = vbNullString
    
    ' Reset the values for if a player is on the map or not
    PlayersOnMap(MapNum) = NO
    
    ' Reset the map cache array for this map.
    MapCache(MapNum).Cache = vbNullString
    
End Sub

Public Sub ClearMaps()
    Dim I As Long
    
    For I = 1 To MAX_MAPS
        Call ClearMap(I)
    Next
End Sub


Public Function GetClassName(ByVal ClassNum As Long) As String
    GetClassName = Trim$(Class(ClassNum).Name)
End Function

Public Function GetClassMaxVital(ByVal ClassNum As Long, ByVal Vital As Vitals) As Long
    Select Case Vital
    Case HP
        GetClassMaxVital = (1 + (Class(ClassNum).Stat(Stats.Strength) \ 2) + Class(ClassNum).Stat(Stats.Strength)) * 2
    Case MP
        GetClassMaxVital = (1 + (Class(ClassNum).Stat(Stats.Magic) \ 2) + Class(ClassNum).Stat(Stats.Magic)) * 2
    Case SP
        GetClassMaxVital = (1 + (Class(ClassNum).Stat(Stats.Speed) \ 2) + Class(ClassNum).Stat(Stats.Speed)) * 2
    End Select
End Function

Public Function GetClassStat(ByVal ClassNum As Long, ByVal Stat As Stats) As Long
    GetClassStat = Class(ClassNum).Stat(Stat)
End Function

' //////////////////////
' // PLAYER FUNCTIONS //
' //////////////////////

Public Function GetPlayerLogin(ByVal Index As Long) As String
    GetPlayerLogin = Trim$(Player(Index).Login)
End Function
Public Sub SetPlayerLogin(ByVal Index As Long, ByVal Login As String)
    Player(Index).Login = Login
End Sub

Public Function GetPlayerPassword(ByVal Index As Long) As String
    GetPlayerPassword = Trim$(Player(Index).Password)
End Function
Public Sub SetPlayerPassword(ByVal Index As Long, ByVal Password As String)
    Player(Index).Password = Password
End Sub

Public Function GetPlayerName(ByVal Index As Long) As String
    GetPlayerName = Trim$(Player(Index).Char(TempPlayer(Index).CharNum).Name)
End Function
Public Sub SetPlayerName(ByVal Index As Long, ByVal Name As String)
    Player(Index).Char(TempPlayer(Index).CharNum).Name = Name
End Sub

Public Function GetPlayerGuild(ByVal Index As Long) As String
    GetPlayerGuild = Trim$(Player(Index).Char(TempPlayer(Index).CharNum).Guild)
End Function
Public Sub SetPlayerGuild(ByVal Index As Long, ByVal Name As String)
    Player(Index).Char(TempPlayer(Index).CharNum).Guild = Name
End Sub

Public Function GetPlayerGAccess(ByVal Index As Long) As Long
    GetPlayerGAccess = Player(Index).Char(TempPlayer(Index).CharNum).GuildAccess
End Function
Public Sub SetPlayerGAccess(ByVal Index As Long, ByVal GAccess As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).GuildAccess = GAccess
End Sub

Public Function GetPlayerClass(ByVal Index As Long) As Long
    GetPlayerClass = Player(Index).Char(TempPlayer(Index).CharNum).Class
End Function
Public Sub SetPlayerClass(ByVal Index As Long, ByVal ClassNum As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).Class = ClassNum
End Sub

Public Function GetPlayerSprite(ByVal Index As Long) As Long
    GetPlayerSprite = Player(Index).Char(TempPlayer(Index).CharNum).Sprite
End Function
Public Sub SetPlayerSprite(ByVal Index As Long, ByVal Sprite As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).Sprite = Sprite
End Sub

Public Function GetPlayerLevel(ByVal Index As Long) As Long
    GetPlayerLevel = Player(Index).Char(TempPlayer(Index).CharNum).Level
End Function
Public Sub SetPlayerLevel(ByVal Index As Long, ByVal Level As Long)
    If Level > MAX_LEVELS Then Exit Sub
    Player(Index).Char(TempPlayer(Index).CharNum).Level = Level
End Sub

Public Function GetPlayerNextLevel(ByVal Index As Long) As Long
    GetPlayerNextLevel = (GetPlayerLevel(Index) + 1) * (GetPlayerStat(Index, Stats.Strength) + GetPlayerStat(Index, Stats.Defense) + GetPlayerStat(Index, Stats.Magic) + GetPlayerStat(Index, Stats.Speed) + GetPlayerPOINTS(Index)) * 25
End Function

Public Function GetPlayerExp(ByVal Index As Long) As Long
    GetPlayerExp = Player(Index).Char(TempPlayer(Index).CharNum).Exp
End Function
Public Sub SetPlayerExp(ByVal Index As Long, ByVal Exp As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).Exp = Exp
End Sub

Public Function GetPlayerAccess(ByVal Index As Long) As Long
    GetPlayerAccess = Player(Index).Char(TempPlayer(Index).CharNum).Access
End Function
Public Sub SetPlayerAccess(ByVal Index As Long, ByVal Access As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).Access = Access
End Sub

Public Function GetPlayerPK(ByVal Index As Long) As Long
    GetPlayerPK = Player(Index).Char(TempPlayer(Index).CharNum).PK
End Function
Public Sub SetPlayerPK(ByVal Index As Long, ByVal PK As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).PK = PK
End Sub

Public Function GetPlayerVital(ByVal Index As Long, ByVal Vital As Vitals) As Long
    GetPlayerVital = Player(Index).Char(TempPlayer(Index).CharNum).Vital(Vital)
End Function
Public Sub SetPlayerVital(ByVal Index As Long, ByVal Vital As Vitals, ByVal value As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).Vital(Vital) = value
    
    If GetPlayerVital(Index, Vital) > GetPlayerMaxVital(Index, Vital) Then
        Player(Index).Char(TempPlayer(Index).CharNum).Vital(Vital) = GetPlayerMaxVital(Index, Vital)
    End If
    If GetPlayerVital(Index, Vital) < 0 Then
        Player(Index).Char(TempPlayer(Index).CharNum).Vital(Vital) = 0
    End If
End Sub

Public Function GetPlayerMaxVital(ByVal Index As Long, ByVal Vital As Vitals) As Long
    Dim CharNum As Long
    
    Select Case Vital
    Case HP
        CharNum = TempPlayer(Index).CharNum
        GetPlayerMaxVital = (Player(Index).Char(CharNum).Level + (GetPlayerStat(Index, Stats.Strength) \ 2) + Class(Player(Index).Char(CharNum).Class).Stat(Stats.Strength)) * 2
    Case MP
        CharNum = TempPlayer(Index).CharNum
        GetPlayerMaxVital = (Player(Index).Char(CharNum).Level + (GetPlayerStat(Index, Stats.Magic) \ 2) + Class(Player(Index).Char(CharNum).Class).Stat(Stats.Magic)) * 2
    Case SP
        CharNum = TempPlayer(Index).CharNum
        GetPlayerMaxVital = (Player(Index).Char(CharNum).Level + (GetPlayerStat(Index, Stats.Speed) \ 2) + Class(Player(Index).Char(CharNum).Class).Stat(Stats.Speed)) * 2
    End Select
End Function

Public Function GetPlayerStat(ByVal Index As Long, ByVal Stat As Stats) As Long
    GetPlayerStat = Player(Index).Char(TempPlayer(Index).CharNum).Stat(Stat)
End Function
Public Sub SetPlayerStat(ByVal Index As Long, ByVal Stat As Stats, ByVal value As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).Stat(Stat) = value
End Sub

Public Function GetPlayerPOINTS(ByVal Index As Long) As Long
    GetPlayerPOINTS = Player(Index).Char(TempPlayer(Index).CharNum).POINTS
End Function
Public Sub SetPlayerPOINTS(ByVal Index As Long, ByVal POINTS As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).POINTS = POINTS
End Sub

Public Function GetPlayerMap(ByVal Index As Long) As Long
    GetPlayerMap = Player(Index).Char(TempPlayer(Index).CharNum).Map
End Function
Public Sub SetPlayerMap(ByVal Index As Long, ByVal MapNum As Long)
    If MapNum > 0 And MapNum <= MAX_MAPS Then
        Player(Index).Char(TempPlayer(Index).CharNum).Map = MapNum
    End If
End Sub

Public Function GetPlayerX(ByVal Index As Long) As Long
    GetPlayerX = Player(Index).Char(TempPlayer(Index).CharNum).X
End Function
Public Sub SetPlayerX(ByVal Index As Long, ByVal X As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).X = X
End Sub

Public Function GetPlayerY(ByVal Index As Long) As Long
    GetPlayerY = Player(Index).Char(TempPlayer(Index).CharNum).Y
End Function
Public Sub SetPlayerY(ByVal Index As Long, ByVal Y As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).Y = Y
End Sub

Public Function GetPlayerDir(ByVal Index As Long) As Long
    GetPlayerDir = Player(Index).Char(TempPlayer(Index).CharNum).Dir
End Function
Public Sub SetPlayerDir(ByVal Index As Long, ByVal Dir As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).Dir = Dir
End Sub

Public Function GetPlayerIP(ByVal Index As Long) As String
    GetPlayerIP = frmServer.Socket(Index).RemoteHostIP
End Function

Public Function GetPlayerInvItemNum(ByVal Index As Long, ByVal InvSlot As Long) As Long
    GetPlayerInvItemNum = Player(Index).Char(TempPlayer(Index).CharNum).Inv(InvSlot).Num
End Function
Public Sub SetPlayerInvItemNum(ByVal Index As Long, ByVal InvSlot As Long, ByVal ItemNum As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).Inv(InvSlot).Num = ItemNum
End Sub

Public Function GetPlayerInvItemValue(ByVal Index As Long, ByVal InvSlot As Long) As Long
    GetPlayerInvItemValue = Player(Index).Char(TempPlayer(Index).CharNum).Inv(InvSlot).value
End Function
Public Sub SetPlayerInvItemValue(ByVal Index As Long, ByVal InvSlot As Long, ByVal ItemValue As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).Inv(InvSlot).value = ItemValue
End Sub

Public Function GetPlayerInvItemDur(ByVal Index As Long, ByVal InvSlot As Long) As Long
    GetPlayerInvItemDur = Player(Index).Char(TempPlayer(Index).CharNum).Inv(InvSlot).Dur
End Function
Public Sub SetPlayerInvItemDur(ByVal Index As Long, ByVal InvSlot As Long, ByVal ItemDur As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).Inv(InvSlot).Dur = ItemDur
End Sub

Public Function GetPlayerSpell(ByVal Index As Long, ByVal SpellSlot As Long) As Long
    GetPlayerSpell = Player(Index).Char(TempPlayer(Index).CharNum).Spell(SpellSlot)
End Function
Public Sub SetPlayerSpell(ByVal Index As Long, ByVal SpellSlot As Long, ByVal SpellNum As Long)
    Player(Index).Char(TempPlayer(Index).CharNum).Spell(SpellSlot) = SpellNum
End Sub

Public Function GetPlayerEquipmentSlot(ByVal Index As Long, ByVal EquipmentSlot As Equipment) As Byte
    GetPlayerEquipmentSlot = Player(Index).Char(TempPlayer(Index).CharNum).Equipment(EquipmentSlot)
End Function
Public Sub SetPlayerEquipmentSlot(ByVal Index As Long, ByVal InvNum As Long, ByVal EquipmentSlot As Equipment)
    Player(Index).Char(TempPlayer(Index).CharNum).Equipment(EquipmentSlot) = InvNum
End Sub

Public Function GetPlayerInvItemName(ByVal Index As Long, ByVal InvSlot As Long) As String
    Dim ItemNum As Long
    ItemNum = GetPlayerInvItemNum(Index, InvSlot)
    If ItemNum > 0 Then
        GetPlayerInvItemName = Trim$(Item(ItemNum).Name)
    End If
End Function


